var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Store, ReadModel } from '../transmute-framework';
import R from './Reducer';
var MAPPER_ENCODING = 'I';
var PackageService = /** @class */ (function () {
    function PackageService(relic, packageManager, eventStoreAdapter, readModelAdapter) {
        var _this = this;
        this.relic = relic;
        this.packageManager = packageManager;
        this.eventStoreAdapter = eventStoreAdapter;
        this.readModelAdapter = readModelAdapter;
        this.requireLatestReadModel = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.getReadModel()
                            // if (!this.readModel) {
                            //   this.readModel = await this.getReadModel();
                            // } else {
                            //   this.readModel.sync(this.packageManager, this.eventStoreAdapter, this.relic.web3);
                            // }
                        ];
                    case 1:
                        _a.readModel = _b.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.publishPackage = function (multihash, name, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
            var events;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.requireLatestReadModel()];
                    case 1:
                        _a.sent();
                        if (this.readModel.state.model[multihash]) {
                            throw new Error('package already exists in read model.');
                        }
                        return [4 /*yield*/, Store.writeFSA(this.packageManager, this.eventStoreAdapter, this.relic.web3, fromAddress, {
                                type: 'PACKAGE_UPDATED',
                                payload: {
                                    name: name,
                                    multihash: multihash
                                },
                                meta: {
                                    adapter: MAPPER_ENCODING
                                }
                            })];
                    case 2:
                        events = _a.sent();
                        return [4 /*yield*/, this.requireLatestReadModel()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, events];
                }
            });
        }); };
        this.deletePackage = function (multihash, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
            var event;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.requireLatestReadModel()];
                    case 1:
                        _a.sent();
                        if (!this.readModel.state.model[multihash]) {
                            throw new Error('package does not exist in read model.');
                        }
                        return [4 /*yield*/, Store.writeFSA(this.packageManager, this.eventStoreAdapter, this.relic.web3, fromAddress, {
                                type: 'PACKAGE_DELETED',
                                payload: {
                                    multihash: multihash
                                },
                                meta: {
                                    adapter: MAPPER_ENCODING
                                }
                            })];
                    case 2:
                        event = _a.sent();
                        return [4 /*yield*/, this.requireLatestReadModel()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, event];
                }
            });
        }); };
        this.getReadModel = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var state, getStat, getAdapterMetaFromEvent, interceptorChain, changes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        state = JSON.parse(JSON.stringify(R.initialState));
                        state.contractAddress = this.packageManager.address;
                        state.readModelStoreKey = state.readModelType + ":" + state.contractAddress;
                        getStat = function (mhash) {
                            return new Promise(function (resolve, reject) {
                                _this.eventStoreAdapter.mapper[MAPPER_ENCODING].db.stat(mhash, function (err, result) {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve(result);
                                    }
                                });
                            });
                        };
                        getAdapterMetaFromEvent = function (action) { return __awaiter(_this, void 0, void 0, function () {
                            var eventMultihash, eventStat, packageStat;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        eventMultihash = action.meta.adapterPayload.value;
                                        return [4 /*yield*/, getStat(eventMultihash)];
                                    case 1:
                                        eventStat = _a.sent();
                                        return [4 /*yield*/, getStat(action.payload.multihash)];
                                    case 2:
                                        packageStat = _a.sent();
                                        return [2 /*return*/, {
                                                eventHash: eventMultihash,
                                                eventSize: eventStat.CumulativeSize,
                                                packageHash: action.payload.multihash,
                                                packageSize: packageStat.CumulativeSize
                                            }];
                                }
                            });
                        }); };
                        interceptorChain = [
                            function (event) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(event.type === 'PACKAGE_UPDATED')) return [3 /*break*/, 2];
                                            _a = event.meta;
                                            return [4 /*yield*/, getAdapterMetaFromEvent(event)];
                                        case 1:
                                            _a.adapterMeta = _b.sent();
                                            _b.label = 2;
                                        case 2: return [2 /*return*/, event];
                                    }
                                });
                            }); },
                            function (event) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(event.type === 'PACKAGE_DELETED')) return [3 /*break*/, 2];
                                            _a = event.meta;
                                            return [4 /*yield*/, getAdapterMetaFromEvent(event)];
                                        case 1:
                                            _a.adapterMeta = _b.sent();
                                            event.meta.updateAdapterMeta = true;
                                            _b.label = 2;
                                        case 2: return [2 /*return*/, event];
                                    }
                                });
                            }); }
                        ];
                        if (!this.readModel) {
                            this.readModel = new ReadModel(this.readModelAdapter, R.reducer, state, interceptorChain);
                        }
                        return [4 /*yield*/, this.readModel.sync(this.packageManager, this.eventStoreAdapter, this.relic.web3)
                            // console.log(JSON.stringify(ipfsReadModel, null, 2))
                        ];
                    case 1:
                        changes = _a.sent();
                        // console.log(JSON.stringify(ipfsReadModel, null, 2))
                        return [2 /*return*/, this.readModel];
                }
            });
        }); };
        // console.log("created...");
    }
    return PackageService;
}());
export default PackageService;
//# sourceMappingURL=PackageService.js.map