var jiff = require("jiff");
export var Patch;
(function (Patch) {
    Patch.statesToPatches = function (states) {
        var patches = [];
        for (var i = 0; i <= states.length - 2; i++) {
            patches.push(jiff.diff(states[i], states[i + 1]));
        }
        return patches;
    };
    Patch.applyPatches = function (state, patches) {
        var patched = JSON.parse(JSON.stringify(state)); // deep copy
        patches.forEach(function (patch) {
            patched = jiff.patchInPlace(patch, patched);
        });
        return patched;
    };
})(Patch || (Patch = {}));
//# sourceMappingURL=Patch.js.map