var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Store, Interceptor } from '../../transmute-framework';
var STATE_REQUIRED_PROPS = [
    'contractAddress',
    'readModelType',
    'readModelStoreKey'
];
var ReadModel = /** @class */ (function () {
    function ReadModel(readModelAdapter, reducer, state, interceptors) {
        var _this = this;
        this.readModelAdapter = readModelAdapter;
        this.reducer = reducer;
        this.state = state;
        this.interceptors = interceptors;
        this.requireStateToHaveDefaultProperties = function (state) {
            STATE_REQUIRED_PROPS.forEach(function (prop) {
                if (state[prop] === undefined ||
                    state[prop] === '' ||
                    state[prop] === '0x0000000000000000000000000000000000000000') {
                    throw new Error("state." + prop + " is not defined. make sure its defined before creating a read model.");
                }
            });
            if (state.readModelStoreKey !==
                state.readModelType + ":" + state.contractAddress) {
                throw new Error("state.readModelStoreKey is not formatted correctly. it should be " + state.readModelType + ":" + state.contractAddress);
            }
        };
        this.applyEvents = function (events) {
            for (var i = 0; i < events.length; i++) {
                var event_1 = events[i];
                _this.state = _this.reducer(_this.state, event_1);
            }
        };
        this.sync = function (store, eventStoreAdapter, web3) { return __awaiter(_this, void 0, void 0, function () {
            var changes, backup, _a, e_1, startIndex, events, i;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        changes = false;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        console.warn('read model may be stale.');
                        backup = JSON.parse(JSON.stringify(this.state));
                        _a = this;
                        return [4 /*yield*/, this.readModelAdapter.getItem(this.state.readModelStoreKey)];
                    case 2:
                        _a.state = _b.sent();
                        if (!this.state) {
                            this.state = backup;
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        // this case when we have not persisted a read model before OR
                        // there is a bug is getItem/setItem....
                        changes = true;
                        return [3 /*break*/, 4];
                    case 4:
                        startIndex = this.state.lastEvent !== null ? this.state.lastEvent + 1 : 0;
                        return [4 /*yield*/, Store.readFSAs(store, eventStoreAdapter, web3, startIndex)
                            // Interceptors are used to transform events that have been read from the chain.
                            // encryption, loading, size calcs, etc...
                        ];
                    case 5:
                        events = _b.sent();
                        if (!this.interceptors) return [3 /*break*/, 9];
                        i = 0;
                        _b.label = 6;
                    case 6:
                        if (!(i < this.interceptors.length)) return [3 /*break*/, 9];
                        return [4 /*yield*/, Interceptor.applyAll(this.interceptors, events)];
                    case 7:
                        events = _b.sent();
                        _b.label = 8;
                    case 8:
                        i++;
                        return [3 /*break*/, 6];
                    case 9:
                        changes = changes || events.length > 0;
                        if (!changes) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.applyEvents(events)];
                    case 10:
                        _b.sent();
                        this.readModelAdapter.setItem(this.state.readModelStoreKey, this.state);
                        _b.label = 11;
                    case 11: return [2 /*return*/, changes];
                }
            });
        }); };
        if (readModelAdapter.getItem === undefined) {
            throw new Error('readModelAdapter.getItem is not defined. readModelAdapter must implement IReadModelAdapter');
        }
        if (reducer === undefined) {
            throw new Error('reducer is not defined. pass a reducer to the constructor.');
        }
        if (state === undefined) {
            throw new Error('state is not defined. pass a default state to the constructor.');
        }
        this.requireStateToHaveDefaultProperties(state);
    }
    return ReadModel;
}());
export { ReadModel };
//# sourceMappingURL=ReadModel.js.map