var bs58 = require('bs58');
var web3Utils = require('web3-utils');
var util = require('ethereumjs-util');
export var toAscii = function (value) {
    return util.toAscii(value).replace(/\u0000/g, '');
};
export var isValidAddress = function (address) {
    return util.isValidAddress(address);
};
export var bufferToHex = function (buffer) {
    return util.bufferToHex(buffer);
};
export var setLengthLeft = function (_value, size) {
    return util.setLengthLeft(_value, size);
};
// https://blog.stakeventures.com/articles/smart-contract-terms
export var hex2ipfshash = function (hash) {
    return bs58.encode(new Buffer('1220' + hash.slice(2), 'hex'));
};
export var ipfs2hex = function (ipfshash) {
    return '0x' + new Buffer(bs58.decode(ipfshash).slice(2)).toString('hex');
};
export var isHex = function (h) {
    return h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)
        ? h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)['index'] === 0
        : false;
};
export var formatHex = function (h) { return '0x' + h.replace(/^0x/i, ''); }; // assumes valid hex input .. 0x33/33 -> 0x33
export var hexToNumber = function (h) {
    return web3Utils.hexToNumber(h);
};
export var toChecksumAddress = function (address) {
    return web3Utils.toChecksumAddress(address);
};
export var privateKeyHexToAddress = function (privatKeyHex) {
    return util.privateToAddress(privatKeyHex);
};
//# sourceMappingURL=Utils.js.map