var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import { getDefaultRelic } from '../../../__mocks__/getRelic';
import { W3, Utils, EventTransformer, InternalEventTypes, EventStoreFactory, EventStore } from '../../../transmute-framework';
import MarshalledEvents from '../../../__mocks__/MarshalledEvents';
var WRITE_EVENT_GAS_COST = 4000000;
/**
 * EventStore spec
 */
describe('EventStore', function () {
    var relic;
    var accounts;
    var factory;
    var receipt;
    var events;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getDefaultRelic()];
                case 1:
                    relic = _a.sent();
                    return [4 /*yield*/, relic.getAccounts()];
                case 2:
                    accounts = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var getEventStore = function () { return __awaiter(_this, void 0, void 0, function () {
        var whitelist, factoryEvents;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    whitelist = accounts.slice(0, 3);
                    return [4 /*yield*/, EventStoreFactory.New(W3.TC.txParamsDefaultDeploy(accounts[0]), {
                            _multisig: accounts[0]
                        })
                        // create a new eventStore
                    ];
                case 1:
                    factory = _a.sent();
                    return [4 /*yield*/, factory.createEventStore(whitelist, W3.TC.txParamsDefaultDeploy(accounts[1]))];
                case 2:
                    // create a new eventStore
                    receipt = _a.sent();
                    events = EventTransformer.getFSAsFromReceipt(receipt);
                    factoryEvents = EventTransformer.filterEventsByMeta(events, 'msgSender', accounts[1]);
                    return [2 /*return*/, EventStore.At(factoryEvents[0].payload.value)];
            }
        });
    }); };
    describe('eventStore poisoning is not possible', function () { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            it('the eventStore owner cannot write INTERNAL_EVENT_TYPES via the external writeEvent method', function () { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                var eventStore, internalEventTypes;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, getEventStore()];
                        case 1:
                            eventStore = _a.sent();
                            return [4 /*yield*/, eventStore.getInternalEventTypes()];
                        case 2:
                            internalEventTypes = (_a.sent()).map(Utils.toAscii);
                            expect(internalEventTypes).toEqual(InternalEventTypes.STORE);
                            internalEventTypes.forEach(function (internalEventType) { return __awaiter(_this, void 0, void 0, function () {
                                var event_1, receipt_1, e_1;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 2, , 3]);
                                            event_1 = MarshalledEvents[0];
                                            return [4 /*yield*/, eventStore.writeEvent(internalEventType, event_1.keyType, event_1.valueType, event_1.key, event_1.value, W3.TC.txParamsDefaultDeploy(accounts[0], WRITE_EVENT_GAS_COST))];
                                        case 1:
                                            receipt_1 = _a.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            e_1 = _a.sent();
                                            expect(e_1.message).toBe('VM Exception while processing transaction: revert');
                                            return [3 /*break*/, 3];
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); });
                            return [2 /*return*/];
                    }
                });
            }); });
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=poisoning.tests.js.map