var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import { getDefaultRelic } from '../../../__mocks__/getRelic';
import { W3, Utils, InternalEventTypes, EventTransformer, EventStoreFactory } from '../../../transmute-framework';
/**
 * EventStoreFactory spec
 */
describe('EventStoreFactory', function () {
    var relic;
    var accounts;
    var factory;
    var receipt;
    var events;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getDefaultRelic()];
                case 1:
                    relic = _a.sent();
                    return [4 /*yield*/, relic.getAccounts()];
                case 2:
                    accounts = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('factory lifecycle', function () { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            it('the factory owner can recycle', function () { return __awaiter(_this, void 0, void 0, function () {
                var fundingAmountWei, initialFactoryBalance, factoryOwner, updatedFactoryBalance, initialOwnerBalance, ownerBalanceAfterRecycle;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            fundingAmountWei = 13370000000000000;
                            return [4 /*yield*/, EventStoreFactory.New(W3.TC.txParamsDefaultDeploy(accounts[0]))
                                // factory balance is intially 0
                            ];
                        case 1:
                            // create a new factory
                            factory = _a.sent();
                            return [4 /*yield*/, relic.getBalance(factory.address)];
                        case 2:
                            initialFactoryBalance = _a.sent();
                            expect(initialFactoryBalance).toBe(0);
                            return [4 /*yield*/, factory.owner()];
                        case 3:
                            factoryOwner = _a.sent();
                            expect(relic.web3.utils.toChecksumAddress(factoryOwner)).toBe(accounts[0]);
                            return [4 /*yield*/, factory.sendTransaction({
                                    from: accounts[0],
                                    value: fundingAmountWei
                                })];
                        case 4:
                            // anyone can send the factory wei
                            receipt = _a.sent();
                            return [4 /*yield*/, relic.getBalance(factory.address)];
                        case 5:
                            updatedFactoryBalance = _a.sent();
                            expect(updatedFactoryBalance).toBe(fundingAmountWei);
                            return [4 /*yield*/, relic.getBalance(factoryOwner)
                                // transfers funds to owner via selfdestruct
                            ];
                        case 6:
                            initialOwnerBalance = _a.sent();
                            return [4 /*yield*/, factory.recycle(W3.TC.txParamsDefaultDeploy(accounts[0]))];
                        case 7:
                            // transfers funds to owner via selfdestruct
                            receipt = _a.sent();
                            events = EventTransformer.getFSAsFromReceipt(receipt);
                            expect(events[0].type).toBe(InternalEventTypes.RECYCLED_TO);
                            expect(events[0].payload.value).toBe(Utils.toChecksumAddress(factoryOwner));
                            return [4 /*yield*/, relic.getBalance(factoryOwner)];
                        case 8:
                            ownerBalanceAfterRecycle = _a.sent();
                            expect(ownerBalanceAfterRecycle).toBeGreaterThan(initialOwnerBalance);
                            return [4 /*yield*/, factory.owner()];
                        case 9:
                            // recycled factories are owned by 0x0
                            factoryOwner = _a.sent();
                            expect(factoryOwner).toBe('0x0');
                            return [2 /*return*/];
                    }
                });
            }); });
            it('the factory owner can recycleAndSend', function () { return __awaiter(_this, void 0, void 0, function () {
                var fundingAmountWei, initialFactoryBalance, updatedFactoryBalance, initialRecipientBalance, recipientBalanceAfterRecycle, factoryOwner;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            fundingAmountWei = 13370000000000000;
                            return [4 /*yield*/, EventStoreFactory.New(W3.TC.txParamsDefaultDeploy(accounts[0]))
                                // factory balance is intially 0
                            ];
                        case 1:
                            // create a new factory
                            factory = _a.sent();
                            return [4 /*yield*/, relic.getBalance(factory.address)];
                        case 2:
                            initialFactoryBalance = _a.sent();
                            expect(initialFactoryBalance).toBe(0);
                            return [4 /*yield*/, factory.sendTransaction({
                                    from: accounts[0],
                                    value: fundingAmountWei
                                })];
                        case 3:
                            // anyone can send the factory wei
                            receipt = _a.sent();
                            return [4 /*yield*/, relic.getBalance(factory.address)];
                        case 4:
                            updatedFactoryBalance = _a.sent();
                            expect(updatedFactoryBalance).toBe(fundingAmountWei);
                            return [4 /*yield*/, relic.getBalance(accounts[1])
                                // transfers funds to _recipient via selfdestruct
                            ];
                        case 5:
                            initialRecipientBalance = _a.sent();
                            return [4 /*yield*/, factory.recycleAndSend(accounts[1], W3.TC.txParamsDefaultDeploy(accounts[0]))];
                        case 6:
                            // transfers funds to _recipient via selfdestruct
                            receipt = _a.sent();
                            events = EventTransformer.getFSAsFromReceipt(receipt);
                            expect(events[0].type).toBe(InternalEventTypes.RECYCLED_TO);
                            expect(relic.web3.utils.toChecksumAddress(events[0].payload.value)).toBe(accounts[1]);
                            return [4 /*yield*/, relic.getBalance(accounts[1])];
                        case 7:
                            recipientBalanceAfterRecycle = _a.sent();
                            expect(recipientBalanceAfterRecycle).toBeGreaterThanOrEqual(initialRecipientBalance);
                            return [4 /*yield*/, factory.owner()];
                        case 8:
                            factoryOwner = _a.sent();
                            expect(factoryOwner).toBe('0x0');
                            return [2 /*return*/];
                    }
                });
            }); });
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=lifecycle.tests.js.map