var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import { getDefaultRelic } from '../__mocks__/getRelic';
import { Relic, Utils, Factory, Store } from '../transmute-framework';
var TransmuteCrypto = require('transmute-crypto');
var RPC_HOST = 'http://localhost:8545';
var generateTestWallets = function (num) { return __awaiter(_this, void 0, void 0, function () {
    var sodium, testWallets, i, alice, unPrefixedPrivateKeyHexString, address;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, TransmuteCrypto.getSodium()];
            case 1:
                sodium = _a.sent();
                testWallets = [];
                for (i = 0; i < num; i++) {
                    alice = sodium.crypto_box_keypair();
                    unPrefixedPrivateKeyHexString = sodium.to_hex(alice.privateKey);
                    address = Utils.privateKeyHexToAddress('0x' + unPrefixedPrivateKeyHexString);
                    testWallets.push({
                        address: '0x' + sodium.to_hex(address),
                        privateKey: '0x' + unPrefixedPrivateKeyHexString
                    });
                }
                return [2 /*return*/, testWallets];
        }
    });
}); };
import { getDefaultWeb3, getWeb3FromWalletWithPrivateKey } from '../__mocks__/getWeb3';
/**
 * Relic tests
 */
describe('Relic tests', function () {
    var allWalletBalancesAre = function (relic, testWallets, expectedBalanceWei) { return __awaiter(_this, void 0, void 0, function () {
        var i, bal;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < testWallets.length)) return [3 /*break*/, 4];
                    return [4 /*yield*/, relic.getBalance(testWallets[i].address)];
                case 2:
                    bal = _a.sent();
                    expect(bal).toBe(expectedBalanceWei);
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    var fundWallets = function (relic, defaultAccount, testWallets, amountWei) { return __awaiter(_this, void 0, void 0, function () {
        var i, txhash;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < testWallets.length)) return [3 /*break*/, 4];
                    return [4 /*yield*/, relic.sendWei(defaultAccount, testWallets[i].address, amountWei)];
                case 2:
                    txhash = _a.sent();
                    expect(txhash).toBeDefined();
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    it('can easily fund wallet addresses', function () { return __awaiter(_this, void 0, void 0, function () {
        var relic, defaultAccount, testWallets;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    relic = getDefaultRelic();
                    return [4 /*yield*/, relic.getAccounts()];
                case 1:
                    defaultAccount = (_a.sent())[0];
                    return [4 /*yield*/, generateTestWallets(3)];
                case 2:
                    testWallets = _a.sent();
                    return [4 /*yield*/, allWalletBalancesAre(relic, testWallets, 0)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, fundWallets(relic, defaultAccount, testWallets, 150000000000000000)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, allWalletBalancesAre(relic, testWallets, 150000000000000000)];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('supports changing web3 providers randomly', function () { return __awaiter(_this, void 0, void 0, function () {
        var defaultSetup, defaultRelic, defaultAccounts, walletSetup, walletRelic, walletAccounts, factory, store, events, storeOwner, _a, _b, store2, store2Owner, _c, _d, _e, _f;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0: return [4 /*yield*/, getDefaultWeb3()];
                case 1:
                    defaultSetup = _g.sent();
                    defaultRelic = new Relic(defaultSetup.web3);
                    return [4 /*yield*/, defaultRelic.getAccounts()];
                case 2:
                    defaultAccounts = _g.sent();
                    expect(defaultAccounts.length).toBe(10);
                    return [4 /*yield*/, getWeb3FromWalletWithPrivateKey()];
                case 3:
                    walletSetup = _g.sent();
                    walletRelic = new Relic(walletSetup.web3);
                    return [4 /*yield*/, walletRelic.getAccounts()];
                case 4:
                    walletAccounts = _g.sent();
                    expect(walletAccounts.length).toBe(1);
                    expect(walletAccounts[0]).toBe(Utils.toChecksumAddress(walletSetup.address));
                    return [4 /*yield*/, fundWallets(defaultRelic, defaultAccounts[0], [{ address: walletAccounts[0] }], 150000000000000000)];
                case 5:
                    _g.sent();
                    return [4 /*yield*/, allWalletBalancesAre(defaultRelic, [{ address: walletAccounts[0] }], 150000000000000000)];
                case 6:
                    _g.sent();
                    return [4 /*yield*/, Factory.create(defaultRelic.web3, defaultAccounts[0])];
                case 7:
                    factory = _g.sent();
                    return [4 /*yield*/, Factory.createStore(factory, walletAccounts, defaultRelic.web3, defaultAccounts[0])];
                case 8:
                    store = _g.sent();
                    return [4 /*yield*/, Store.transferOwnership(store, defaultAccounts[0], walletAccounts[0])];
                case 9:
                    events = _g.sent();
                    _b = (_a = Utils).toChecksumAddress;
                    return [4 /*yield*/, store.owner()];
                case 10:
                    storeOwner = _b.apply(_a, [_g.sent()]);
                    expect(storeOwner).toBe(walletAccounts[0]);
                    return [4 /*yield*/, Store.get(store.address, walletRelic.web3)];
                case 11:
                    store2 = _g.sent();
                    _d = (_c = Utils).toChecksumAddress;
                    return [4 /*yield*/, store2.owner()];
                case 12:
                    store2Owner = _d.apply(_c, [_g.sent()]);
                    expect(storeOwner).toEqual(store2Owner);
                    return [4 /*yield*/, Store.transferOwnership(store2, store2Owner, defaultAccounts[2])];
                case 13:
                    events = _g.sent();
                    _f = (_e = Utils).toChecksumAddress;
                    return [4 /*yield*/, store2.owner()];
                case 14:
                    store2Owner = _f.apply(_e, [_g.sent()]);
                    expect(defaultAccounts[2]).toEqual(store2Owner);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=relic.tests.js.map