var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import { Relic, Utils, Factory, W3, EventStore } from '../transmute-framework';
var RPC_HOST = 'http://localhost:8545';
import { getAccounts, getDefaultWeb3, getWeb3FromWalletWithPrivateKey } from '../__mocks__/getWeb3';
/**
 * Relic tests
 */
describe('Relic tests', function () {
    it('stores can be transfered between wallet and node addresses', function () { return __awaiter(_this, void 0, void 0, function () {
        var data, defaultWeb3, defaultAccounts, defaultRelic, walletWeb3, walletAccounts, walletRelic, txhash, factory, store, storeOwner, store2, store2Owner;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getDefaultWeb3()];
                case 1:
                    data = _a.sent();
                    defaultWeb3 = data.web3;
                    return [4 /*yield*/, getAccounts(defaultWeb3)];
                case 2:
                    defaultAccounts = _a.sent();
                    defaultRelic = new Relic(defaultWeb3);
                    return [4 /*yield*/, getWeb3FromWalletWithPrivateKey()];
                case 3:
                    data = _a.sent();
                    walletWeb3 = data.web3;
                    return [4 /*yield*/, getAccounts(walletWeb3)];
                case 4:
                    walletAccounts = _a.sent();
                    walletRelic = new Relic(walletWeb3);
                    return [4 /*yield*/, defaultRelic.sendWei(defaultAccounts[0], walletAccounts[0], 150000000000000000)];
                case 5:
                    txhash = _a.sent();
                    expect(txhash).toBeDefined();
                    return [4 /*yield*/, walletRelic.sendWei(walletAccounts[0], defaultAccounts[6], 150000000000000)];
                case 6:
                    txhash = _a.sent();
                    expect(txhash).toBeDefined();
                    return [4 /*yield*/, Factory.create(defaultRelic.web3, defaultAccounts[0])];
                case 7:
                    factory = _a.sent();
                    return [4 /*yield*/, Factory.createStore(factory, walletAccounts.concat(defaultAccounts), defaultRelic.web3, defaultAccounts[0])];
                case 8:
                    store = _a.sent();
                    return [4 /*yield*/, store.owner()];
                case 9:
                    storeOwner = _a.sent();
                    expect(Utils.toChecksumAddress(storeOwner)).toEqual(defaultAccounts[0]);
                    // console.log(storeOwner)
                    return [4 /*yield*/, store.transferOwnership(walletAccounts[0], W3.TC.txParamsDefaultDeploy(storeOwner))];
                case 10:
                    // console.log(storeOwner)
                    _a.sent();
                    return [4 /*yield*/, store.owner()];
                case 11:
                    storeOwner = _a.sent();
                    expect(Utils.toChecksumAddress(storeOwner)).toEqual(walletAccounts[0]);
                    return [4 /*yield*/, EventStore.At(store.address, walletRelic.web3)];
                case 12:
                    store2 = _a.sent();
                    return [4 /*yield*/, store2.owner()];
                case 13:
                    store2Owner = _a.sent();
                    expect(Utils.toChecksumAddress(storeOwner)).toEqual(Utils.toChecksumAddress(store2Owner));
                    return [4 /*yield*/, store2.transferOwnership(defaultAccounts[2], W3.TC.txParamsDefaultDeploy(store2Owner))];
                case 14:
                    _a.sent();
                    return [4 /*yield*/, store2.owner()];
                case 15:
                    store2Owner = _a.sent();
                    expect(Utils.toChecksumAddress(defaultAccounts[2])).toEqual(Utils.toChecksumAddress(store2Owner));
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=wallet.tests.js.map