"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../transmute-framework");
var Reducer_1 = require("./Reducer");
var Factory;
(function (Factory) {
    var _this = this;
    /**
     * Factory create
     */
    Factory.create = function (web3, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
        var instance;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    transmute_framework_1.W3.Default = web3;
                    return [4 /*yield*/, transmute_framework_1.EventStoreFactory.New(transmute_framework_1.W3.TC.txParamsDefaultDeploy(fromAddress), {
                            _multisig: fromAddress
                        })];
                case 1:
                    instance = _a.sent();
                    return [2 /*return*/, instance];
            }
        });
    }); };
    /**
     * Factory createStore
     */
    Factory.createStore = function (factory, whitelist, web3, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
        var receipt, events, factoryEvents;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    transmute_framework_1.W3.Default = web3;
                    return [4 /*yield*/, factory.createEventStore(whitelist, transmute_framework_1.W3.TC.txParamsDefaultDeploy(fromAddress))];
                case 1:
                    receipt = _a.sent();
                    return [4 /*yield*/, transmute_framework_1.EventTransformer.getFSAsFromReceipt(receipt)];
                case 2:
                    events = _a.sent();
                    factoryEvents = transmute_framework_1.EventTransformer.filterEventsByMeta(events, 'msgSender', transmute_framework_1.Utils.toChecksumAddress(fromAddress));
                    return [2 /*return*/, transmute_framework_1.EventStore.At(factoryEvents[0].payload.value)];
            }
        });
    }); };
    Factory.getEventStores = function (factory, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
        var addresses;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, factory.getEventStores(transmute_framework_1.W3.TC.txParamsDefaultDeploy(fromAddress))];
                case 1:
                    addresses = _a.sent();
                    return [2 /*return*/, addresses];
            }
        });
    }); };
    /**
     * Factory getReadModel
     */
    Factory.getReadModel = function (factory, adapter, readModelAdapter, web3, fromAddress) { return __awaiter(_this, void 0, void 0, function () {
        var state, factoryReadModel, changes;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    state = JSON.parse(JSON.stringify(Reducer_1.default.initialState));
                    state.contractAddress = factory.address;
                    state.readModelStoreKey = state.readModelType + ":" + state.contractAddress;
                    factoryReadModel = new transmute_framework_1.ReadModel(readModelAdapter, Reducer_1.default.reducer, state);
                    return [4 /*yield*/, factoryReadModel.sync(factory, adapter, web3)];
                case 1:
                    changes = _a.sent();
                    return [2 /*return*/, factoryReadModel];
            }
        });
    }); };
})(Factory = exports.Factory || (exports.Factory = {}));
//# sourceMappingURL=Factory.js.map