"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../../transmute-framework");
var WRITE_EVENT_GAS_COST = 4000000;
var EventStoreAdapter = /** @class */ (function () {
    function EventStoreAdapter(mapper) {
        var _this = this;
        this.mapper = mapper;
        this.eventMap = {
            EsEvent: function (args) { return __awaiter(_this, void 0, void 0, function () {
                var fsa, mutatingEvent, key, value, adaptedEvent, transparentAdaptedEvent;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            fsa = transmute_framework_1.EventTransformer.esEventToFSA(args);
                            if (fsa.payload !== undefined) {
                                return [2 /*return*/, fsa];
                            }
                            mutatingEvent = {
                                Key: transmute_framework_1.Utils.toAscii(args.Key),
                                KeyType: transmute_framework_1.Utils.toAscii(args.KeyType),
                                Value: args.Value,
                                ValueType: transmute_framework_1.Utils.toAscii(args.ValueType)
                            };
                            // console.log(mutatingEvent.Value);
                            if (!this.mapper[mutatingEvent.ValueType]) {
                                throw new Error('EventStoreAdapter has not mapper for events of valueType: ' +
                                    mutatingEvent.ValueType);
                            }
                            key = this.mapper[mutatingEvent.ValueType].readIDFromBytes32(mutatingEvent.Value);
                            return [4 /*yield*/, this.mapper[mutatingEvent.ValueType].adapter.getItem(this.mapper[mutatingEvent.ValueType].db, key)];
                        case 1:
                            value = _a.sent();
                            adaptedEvent = __assign({}, fsa, { payload: {
                                    key: key,
                                    value: value
                                }, meta: __assign({}, fsa.meta, { adapter: mutatingEvent.ValueType }) });
                            transparentAdaptedEvent = __assign({}, adaptedEvent, { payload: adaptedEvent.payload.value, meta: __assign({}, adaptedEvent.meta, { adapterPayload: {
                                        key: this.mapper[mutatingEvent.ValueType].keyName,
                                        value: adaptedEvent.payload.key
                                    } }) });
                            return [2 /*return*/, transparentAdaptedEvent];
                    }
                });
            }); }
        };
        this.convertFSAPayload = function (fsa) { return __awaiter(_this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = [{}, fsa];
                        _b = {};
                        _c = {
                            key: this.mapper[fsa.meta.adapter].keyName
                        };
                        return [4 /*yield*/, this.setItem(this.mapper[fsa.meta.adapter].adapter, this.mapper[fsa.meta.adapter].db, fsa.payload)];
                    case 1: return [2 /*return*/, __assign.apply(void 0, _a.concat([(_b.payload = (_c.value = _d.sent(),
                                _c), _b)]))];
                }
            });
        }); };
        this.getEsEventParamsFromFSA = function (event) { return __awaiter(_this, void 0, void 0, function () {
            var esEventParams, _a, adaptedEvent;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = transmute_framework_1.EventTransformer.getFSAType(event);
                        switch (_a) {
                            case transmute_framework_1.EventTransformer.FSATypes.Adapter: return [3 /*break*/, 1];
                            case transmute_framework_1.EventTransformer.FSATypes.SimpleKeyValue: return [3 /*break*/, 3];
                            case transmute_framework_1.EventTransformer.FSATypes.Native: return [3 /*break*/, 4];
                        }
                        return [3 /*break*/, 5];
                    case 1:
                        if (event.meta.adapter === undefined) {
                            throw new Error('fsa.meta.adapter is not defined. be sure to set it when fsa.payload is an object (isAdapterEvent).');
                        }
                        if (this.mapper[event.meta.adapter] === undefined) {
                            throw new Error('mapper not provided for event.meta.adapter: ' + event.meta.adapter);
                        }
                        return [4 /*yield*/, this.convertFSAPayload(event)
                            // console.log("adaptedEvent: ", adaptedEvent);
                        ];
                    case 2:
                        adaptedEvent = _b.sent();
                        // console.log("adaptedEvent: ", adaptedEvent);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: this.mapper[adaptedEvent.meta.adapter].keyName,
                            valueType: adaptedEvent.meta.adapter,
                            valueValue: adaptedEvent.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 3:
                        this.isPayloadMisleading(event);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: event.payload.key,
                            valueType: 'S',
                            valueValue: event.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 4:
                        // throw is format is misleading or wrong...
                        this.isPayloadMisleading(event);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: event.payload.key,
                            valueType: transmute_framework_1.EventTransformer.payloadKeyToKeyType[event.payload.key],
                            valueValue: event.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, esEventParams];
                }
            });
        }); };
        this.writeFSA = function (store, fromAddress, event) { return __awaiter(_this, void 0, void 0, function () {
            var esEventParams, marshalledEvent, receipt, eventsFromLogs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (event.type.length > 32) {
                            throw new Error('fsa.type (S) is more than 32 bytes. value length = ' +
                                event.type.length +
                                ' chars');
                        }
                        return [4 /*yield*/, this.getEsEventParamsFromFSA(event)
                            // console.log("hmm: ", esEventParams);
                        ];
                    case 1:
                        esEventParams = _a.sent();
                        return [4 /*yield*/, this.marshal(event.type, esEventParams.keyType, esEventParams.valueType, esEventParams.keyValue, esEventParams.valueValue)
                            // console.log(JSON.stringify(marshalledEvent));
                        ];
                    case 2:
                        marshalledEvent = _a.sent();
                        return [4 /*yield*/, store.writeEvent(marshalledEvent.eventType, marshalledEvent.keyType, marshalledEvent.valueType, marshalledEvent.key, marshalledEvent.value, transmute_framework_1.W3.TC.txParamsDefaultDeploy(fromAddress, WRITE_EVENT_GAS_COST))
                            // console.log('receipt', receipt)
                        ];
                    case 3:
                        receipt = _a.sent();
                        return [4 /*yield*/, this.extractEventsFromLogs(receipt.logs)
                            // console.log(eventsFromLogs)
                        ];
                    case 4:
                        eventsFromLogs = _a.sent();
                        // console.log(eventsFromLogs)
                        if (receipt.logs.length > 1) {
                            throw new Error('more than 1 event in write event log...');
                        }
                        return [2 /*return*/, eventsFromLogs[0]];
                }
            });
        }); };
        this.throwOnAdapterTypeCollision = function () {
            _this.mapperKeys.forEach(function (mapperKey) {
                if (transmute_framework_1.TransmuteSolidityEncodingTypes.indexOf(mapperKey) !== -1) {
                    throw new Error('Mapper keys cannot container reserved encoding types: ' +
                        transmute_framework_1.TransmuteSolidityEncodingTypes);
                }
            });
        };
        this.throwOnAdapterTypeConversionUndefined = function () {
            _this.mapperKeys.forEach(function (mapperKey) {
                if (_this.mapper[mapperKey] === undefined ||
                    _this.mapper[mapperKey].readIDFromBytes32 === undefined) {
                    throw new Error('Mapper : ' + mapperKey + ' does not implement IAdapterMapper');
                }
            });
        };
        this.getItem = function (adapter, db, key) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, adapter.getItem(db, key)];
            });
        }); };
        this.setItem = function (adapter, db, value) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, adapter.setItem(db, value)];
            });
        }); };
        this.isPayloadKeySizeSafe = function (keyValue, keyType) {
            // ensure key does not exceed keyType size (bytes32 safety check)
            return keyValue.length <= 32;
        };
        this.isPayloadMisleading = function (event) {
            if (event.payload.key === 'bytes32') {
                if (event.meta.valueType === 'B') {
                    // check length
                    if (event.payload.value.length > 66) {
                        // check hex chars only 0-f/F
                        if (!transmute_framework_1.Utils.isHex(event.payload.value)) {
                            throw new Error('solidity bytes32 received invalid hex string: ' +
                                event.payload.value);
                        }
                    }
                }
                if (event.meta.valueType === 'S') {
                    if (event.payload.value.length > 32) {
                        throw new Error('payload value of type (S) is more than 32 bytes. value length = ' +
                            event.payload.value.length +
                            ' chars');
                    }
                }
            }
            if (event.payload.key === 'address') {
                if (!transmute_framework_1.Utils.isValidAddress(event.payload.value)) {
                    throw new Error('payload of address type has none address value. ' +
                        event.payload.value +
                        ' is not a valid address.');
                }
            }
        };
        this.convertValueToType = function (_valueType, _value) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (_valueType === 'B') {
                            return [2 /*return*/, _value];
                        }
                        if (!this.mapper[_valueType]) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.mapper[_valueType].writeIDToBytes32(_value)];
                    case 1:
                        _value = _a.sent();
                        _a.label = 2;
                    case 2:
                        // // Left padd ints and addresses for bytes32 equivalence of Solidity casting
                        if (_valueType === 'U' || _valueType === 'A') {
                            _value = transmute_framework_1.Utils.bufferToHex(transmute_framework_1.Utils.setLengthLeft(_value, 32));
                        }
                        return [2 /*return*/, _value];
                }
            });
        }); };
        this.marshal = function (_eventType, _keyType, _valueType, _key, _value) { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = {
                            eventType: _eventType,
                            keyType: _keyType,
                            valueType: _valueType
                        };
                        return [4 /*yield*/, this.convertValueToType(_keyType, _key)];
                    case 1:
                        _a.key = _b.sent();
                        return [4 /*yield*/, this.convertValueToType(_valueType, _value)];
                    case 2: return [2 /*return*/, (_a.value = _b.sent(),
                            _a)];
                }
            });
        }); };
        this.extractEventsFromLogs = function (logs) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, Promise.all(logs.map(function (log) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, this.eventMap[log.event](log.args)];
                        });
                    }); }))];
            });
        }); };
        this.mapperKeys = Object.keys(mapper);
        this.throwOnAdapterTypeCollision();
        this.throwOnAdapterTypeConversionUndefined();
    }
    return EventStoreAdapter;
}());
exports.EventStoreAdapter = EventStoreAdapter;
//# sourceMappingURL=EventStoreAdapter.js.map