"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var bs58 = require('bs58');
var transmute_framework_1 = require("../../../transmute-framework");
/**
 * Good EventStoreAdapter tests
 */
describe('Good adapter tests', function () {
    var storeTypeAdapter;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        var ipfsAdapter, ipfs;
        return __generator(this, function (_a) {
            ipfsAdapter = require('../../../../../transmute-adapter-ipfs');
            ipfs = ipfsAdapter.getStorage();
            storeTypeAdapter = new transmute_framework_1.EventStoreAdapter({
                I: {
                    keyName: 'multihash',
                    adapter: ipfsAdapter,
                    db: ipfs,
                    readIDFromBytes32: function (bytes32) {
                        return bs58.encode(new Buffer('1220' + bytes32.slice(2), 'hex'));
                    },
                    writeIDToBytes32: function (id) {
                        return '0x' + new Buffer(bs58.decode(id).slice(2)).toString('hex');
                    }
                }
            });
            return [2 /*return*/];
        });
    }); });
    // uses event.meta.adapter to transform event.payload
    it('convertFSAPayload ', function () { return __awaiter(_this, void 0, void 0, function () {
        var adapterFSAEvent, converted;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    adapterFSAEvent = {
                        type: 'test',
                        payload: {
                            key1: 'multihash',
                            value2: '0x01000c268181f5d90587392ff67ada1a16393fe4',
                            value3: null
                        },
                        meta: {
                            adapter: 'I'
                        }
                    };
                    return [4 /*yield*/, storeTypeAdapter.convertFSAPayload(adapterFSAEvent)];
                case 1:
                    converted = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('supports ipfs ', function () { return __awaiter(_this, void 0, void 0, function () {
        var ipfsAdapter, ipfs, storeTypeAdapter, payload, encodedId, decodedId;
        return __generator(this, function (_a) {
            ipfsAdapter = require('../../../../../transmute-adapter-ipfs');
            ipfs = ipfsAdapter.getStorage();
            storeTypeAdapter = new transmute_framework_1.EventStoreAdapter({
                I: {
                    keyName: 'multihash',
                    adapter: ipfsAdapter,
                    db: ipfs,
                    readIDFromBytes32: function (bytes32) {
                        return bs58.encode(new Buffer('1220' + bytes32.slice(2), 'hex'));
                    },
                    writeIDToBytes32: function (id) {
                        return '0x' + new Buffer(bs58.decode(id).slice(2)).toString('hex');
                    }
                }
            });
            payload = {
                multihash: 'QmcEMXuJYiyDQpbU1BaFQngaBajPEs9UUHuQnPUYSLWa1B'
            };
            encodedId = storeTypeAdapter.mapper['I'].writeIDToBytes32(payload.multihash);
            decodedId = storeTypeAdapter.mapper['I'].readIDFromBytes32(encodedId);
            expect(payload.multihash).toBe(decodedId);
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=good.adapter.js.map