"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../../../transmute-framework");
/**
 * Interceptor test
 */
describe('Interceptor test', function () {
    it('apply can transform events ', function () { return __awaiter(_this, void 0, void 0, function () {
        var events, interceptedEvents, expectedResult, interceptedEvents2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    events = [
                        {
                            type: 'TEST_1',
                            payload: {
                                heavy1: {
                                    hello: 'world'
                                },
                                heavy2: {
                                    hello: 'world'
                                },
                                heavy3: {
                                    hello: 'world'
                                }
                            },
                            meta: {
                                adapter: 'I'
                            }
                        },
                        {
                            type: 'TEST_2',
                            payload: {
                                heavy1: {
                                    hello: 'world'
                                },
                                heavy2: {
                                    hello: 'world'
                                },
                                heavy3: {
                                    hello: 'world'
                                }
                            },
                            meta: {
                                adapter: 'N'
                            }
                        }
                    ];
                    return [4 /*yield*/, transmute_framework_1.Interceptor.apply(function (event) {
                            // Imagine doing more complicated async writing in here...
                            if (event.meta.adapter === 'I') {
                                Object.keys(event.payload).forEach(function (payloadKey) {
                                    event.payload[payloadKey] = 'Qme7DMBUe1EjXAKoEXzNh7G7NgMeGw9i2uLfB9bKVR7hHZ';
                                });
                            }
                            if (event.meta.adapter === 'N') {
                                Object.keys(event.payload).forEach(function (payloadKey) {
                                    event.payload[payloadKey] = '2248ee2fa0aaaad99178531f924bf00b4b0a8f4e';
                                });
                            }
                            return event;
                        }, events)];
                case 1:
                    interceptedEvents = _a.sent();
                    expectedResult = [
                        {
                            type: 'TEST_1',
                            payload: {
                                heavy1: 'Qme7DMBUe1EjXAKoEXzNh7G7NgMeGw9i2uLfB9bKVR7hHZ',
                                heavy2: 'Qme7DMBUe1EjXAKoEXzNh7G7NgMeGw9i2uLfB9bKVR7hHZ',
                                heavy3: 'Qme7DMBUe1EjXAKoEXzNh7G7NgMeGw9i2uLfB9bKVR7hHZ'
                            },
                            meta: {
                                adapter: 'I'
                            }
                        },
                        {
                            type: 'TEST_2',
                            payload: {
                                heavy1: '2248ee2fa0aaaad99178531f924bf00b4b0a8f4e',
                                heavy2: '2248ee2fa0aaaad99178531f924bf00b4b0a8f4e',
                                heavy3: '2248ee2fa0aaaad99178531f924bf00b4b0a8f4e'
                            },
                            meta: {
                                adapter: 'N'
                            }
                        }
                    ];
                    expect(interceptedEvents).toEqual(expectedResult);
                    return [4 /*yield*/, transmute_framework_1.Interceptor.apply(function (event) {
                            // Imagine doing more complicated async reading in here...
                            Object.keys(event.payload).forEach(function (payloadKey) {
                                if (payloadKey.indexOf('heavy') !== -1) {
                                    event.payload[payloadKey] = {
                                        hello: 'world'
                                    };
                                }
                            });
                            return event;
                        }, events)];
                case 2:
                    interceptedEvents2 = _a.sent();
                    expect(interceptedEvents2).toEqual(events);
                    return [2 /*return*/];
            }
        });
    }); });
    it('applyAll uses apply', function () { return __awaiter(_this, void 0, void 0, function () {
        var events, results;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    events = [
                        {
                            type: 'TEST_1',
                            payload: {
                                heavy1: {
                                    hello: 'world'
                                }
                            },
                            meta: {
                                adapter: 'I'
                            }
                        },
                        {
                            type: 'TEST_2',
                            payload: {
                                heavy1: {
                                    hello: 'world'
                                }
                            },
                            meta: {
                                adapter: 'N'
                            }
                        }
                    ];
                    return [4 /*yield*/, transmute_framework_1.Interceptor.applyAll([
                            function (event) {
                                return event;
                            },
                            function (event) {
                                return event;
                            }
                        ], events)];
                case 1:
                    results = _a.sent();
                    expect(results).toEqual(events);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=interceptor.tests.js.map