"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constants = require("./constants");
exports.initialState = {
    readModelStoreKey: '',
    readModelType: 'MockReadModel',
    contractAddress: '0x0000000000000000000000000000000000000000',
    lastEvent: null,
    model: {} // where all the updates from events will be made
};
var updatesFromMeta = function (meta) {
    return {
        lastEvent: meta.id
    };
};
exports.handlers = (_a = {},
    _a[Constants.ACCOUNT_CREATED] = function (state, action) {
        return __assign({}, state, { model: __assign({}, state.model, { created: action.payload.value }) }, updatesFromMeta(action.meta));
    },
    _a[Constants.ACCOUNT_NAMED] = function (state, action) {
        return __assign({}, state, { model: __assign({}, state.model, { name: action.payload.value }) }, updatesFromMeta(action.meta));
    },
    _a);
exports.reducer = function (state, action) {
    if (exports.handlers[action.type]) {
        return exports.handlers[action.type](state, action);
    }
    return state;
};
var _a;
//# sourceMappingURL=reducer.js.map