"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../../../transmute-framework");
/**
 * ReadModel readModelAdapter tests
 */
describe('ReadModel readModelAdapter tests', function () {
    var Storage = require('node-storage');
    var store = new Storage('./read_model_storage');
    var readModelAdapter = {
        getItem: function (id) {
            return JSON.parse(store.get(id));
        },
        setItem: function (id, value) {
            return store.put(id, JSON.stringify(value));
        }
    };
    it('throws when readModelAdapter does not implement IReadModelAdapter', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType({});
            }
            catch (e) {
                expect(e.message).toBe('readModelAdapter.getItem is not defined. readModelAdapter must implement IReadModelAdapter');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when reducer is not passed to constructor', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter);
            }
            catch (e) {
                expect(e.message).toBe('reducer is not defined. pass a reducer to the constructor.');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when state is not passwed to constructor', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter, jest.fn());
            }
            catch (e) {
                expect(e.message).toBe('state is not defined. pass a default state to the constructor.');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when state.contractAddress is not defined', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter, jest.fn(), {});
            }
            catch (e) {
                expect(e.message).toBe('state.contractAddress is not defined. make sure its defined before creating a read model.');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when state.readModelType is not defined', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter, jest.fn(), {
                    contractAddress: '0x'
                });
            }
            catch (e) {
                expect(e.message).toBe('state.readModelType is not defined. make sure its defined before creating a read model.');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when state.readModelStoreKey is not defined', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter, jest.fn(), {
                    contractAddress: '0x',
                    readModelType: 'bobo'
                });
            }
            catch (e) {
                expect(e.message).toBe('state.readModelStoreKey is not defined. make sure its defined before creating a read model.');
            }
            return [2 /*return*/];
        });
    }); });
    it('throws when state.readModelStoreKey is not formatted correctly', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, rm;
        return __generator(this, function (_a) {
            try {
                forgottenType = transmute_framework_1.ReadModel;
                rm = new forgottenType(readModelAdapter, jest.fn(), {
                    contractAddress: '0x',
                    readModelType: 'bobo',
                    readModelStoreKey: 'bob2o:0x'
                });
            }
            catch (e) {
                expect(e.message).toBe('state.readModelStoreKey is not formatted correctly. it should be bobo:0x');
            }
            return [2 /*return*/];
        });
    }); });
    it('supports node-storage readModelAdapter', function () { return __awaiter(_this, void 0, void 0, function () {
        var forgottenType, reducer, state, rm;
        return __generator(this, function (_a) {
            forgottenType = transmute_framework_1.ReadModel;
            reducer = jest.fn();
            state = {
                contractAddress: '0x',
                readModelType: 'bobo',
                readModelStoreKey: 'bobo:0x'
            };
            rm = new forgottenType(readModelAdapter, reducer, state);
            expect(rm).toBeDefined();
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=constructor.tests.js.map