"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../transmute-framework");
exports.GAS_COSTS = {
    WRITE_EVENT: 4000000
};
var Store;
(function (Store) {
    var _this = this;
    // useful when changing web3 providers...
    Store.get = function (address, web3) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, transmute_framework_1.EventStore.At(address, web3)];
        });
    }); };
    /**
     * Store eventCount
     */
    Store.eventCount = function (store) { return __awaiter(_this, void 0, void 0, function () {
        var countBigNumber;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.eventCount()];
                case 1:
                    countBigNumber = _a.sent();
                    return [2 /*return*/, countBigNumber.toNumber()];
            }
        });
    }); };
    Store.transferOwnership = function (store, from, to) { return __awaiter(_this, void 0, void 0, function () {
        var receipt, events;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.transferOwnership(to.toLowerCase(), transmute_framework_1.W3.TC.txParamsDefaultDeploy(from.toLowerCase()))];
                case 1:
                    receipt = _a.sent();
                    events = transmute_framework_1.EventTransformer.getFSAsFromReceipt(receipt);
                    return [2 /*return*/, events];
            }
        });
    }); };
    /**
     * Store readFSA
     */
    Store.readFSA = function (store, eventStoreAdapter, web3, eventId) { return __awaiter(_this, void 0, void 0, function () {
        var solidityValues, esEvent;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.readEvent(eventId)];
                case 1:
                    solidityValues = _a.sent();
                    return [4 /*yield*/, transmute_framework_1.EventTransformer.valuesToEsEvent(solidityValues[0], solidityValues[1], solidityValues[2], solidityValues[3], solidityValues[4], solidityValues[5], solidityValues[6], solidityValues[7], solidityValues[8])];
                case 2:
                    esEvent = _a.sent();
                    return [2 /*return*/, eventStoreAdapter.eventMap.EsEvent(esEvent)];
            }
        });
    }); };
    /**
     * Store writeFSA
     */
    Store.writeFSA = function (store, eventStoreAdapter, web3, fromAddress, event) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (typeof event.payload === 'string') {
                throw new Error('event.payload must be an object, not a string.');
            }
            if (Array.isArray(event.payload)) {
                throw new Error('event.payload must be an object, not an array.');
            }
            return [2 /*return*/, eventStoreAdapter.writeFSA(store, fromAddress, event)];
        });
    }); };
    Store.writeFSAs = function (store, eventStoreAdapter, web3, fromAddress, events) { return __awaiter(_this, void 0, void 0, function () {
        var writtenEvents, i, event_1, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    writtenEvents = [];
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < events.length)) return [3 /*break*/, 4];
                    event_1 = events[i];
                    _b = (_a = writtenEvents).push;
                    return [4 /*yield*/, Store.writeFSA(store, eventStoreAdapter, web3, fromAddress, event_1)];
                case 2:
                    _b.apply(_a, [_c.sent()]);
                    _c.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, writtenEvents];
            }
        });
    }); };
    Store.readFSAs = function (store, eventStoreAdapter, web3, eventIndex) {
        if (eventIndex === void 0) { eventIndex = 0; }
        return __awaiter(_this, void 0, void 0, function () {
            var endIndex, events, i, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, Store.eventCount(store)];
                    case 1:
                        endIndex = _c.sent();
                        events = [];
                        i = eventIndex;
                        _c.label = 2;
                    case 2:
                        if (!(i < endIndex)) return [3 /*break*/, 5];
                        _b = (_a = events).push;
                        return [4 /*yield*/, Store.readFSA(store, eventStoreAdapter, web3, i)];
                    case 3:
                        _b.apply(_a, [_c.sent()]);
                        _c.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, Promise.all(events)];
                }
            });
        });
    };
})(Store = exports.Store || (exports.Store = {}));
//# sourceMappingURL=Store.js.map