"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var setup_1 = require("../../__mocks__/setup");
var transmute_framework_1 = require("../../transmute-framework");
var Storage = require('node-storage');
var WRITE_EVENT_GAS_COST = 4000000;
/**
 * Store test
 */
describe('Store', function () {
    var relic;
    var accounts;
    var store;
    var eventStoreAdapter;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        var setup;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, setup_1.getSetupAsync()];
                case 1:
                    setup = _a.sent();
                    relic = setup.relic;
                    store = setup.store;
                    accounts = setup.accounts;
                    eventStoreAdapter = setup.eventStoreAdapter;
                    return [2 /*return*/];
            }
        });
    }); });
    it('throws error when eventStoreAdapter not provided for payload meta.eventStoreAdapter', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'value',
                                key2: 'value2'
                            },
                            meta: {
                                adapter: 'Q'
                            }
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _a.sent();
                    expect(e_1.message).toBe('mapper not provided for event.meta.adapter: Q');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when invalid payload is string.', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: 'INVALID SHAPE',
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_2 = _a.sent();
                    expect(e_2.message).toBe('event.payload must be an object, not a string.');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when invalid payload is array.', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: [1, 2, 3],
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_3 = _a.sent();
                    expect(e_3.message).toBe('event.payload must be an object, not an array.');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is to large', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                REALLY_LARGE_KEY_BIGGER_THAN_BYTES_32_STRING______________________: 'value'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_4 = _a.sent();
                    expect(e_4.message).toBe('fsa.meta.adapter is not defined. be sure to set it when fsa.payload is an object (isAdapterEvent).');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is address, and value is not valid address', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_5;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'address',
                                value: 'NOT_AN_ADDRESS'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_5 = _a.sent();
                    expect(e_5.message).toBe('payload of address type has none address value. NOT_AN_ADDRESS is not a valid address.');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is address, and value invalid hex: x1E63f28550ae27e0a192d91d073ea4e97dd089b0', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_6;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'address',
                                value: 'x1E63f28550ae27e0a192d91d073ea4e97dd089b0'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_6 = _a.sent();
                    expect(e_6.message).toBe('payload of address type has none address value. x1E63f28550ae27e0a192d91d073ea4e97dd089b0 is not a valid address.');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is address, and value invalid hex: 1E63f28550ae27e0a192d91d073ea4e97dd089b0', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_7;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'address',
                                value: '1E63f28550ae27e0a192d91d073ea4e97dd089b0'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_7 = _a.sent();
                    expect(e_7.message).toBe('payload of address type has none address value. 1E63f28550ae27e0a192d91d073ea4e97dd089b0 is not a valid address.');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is bytes32, and value is larger than bytes32', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_8;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'bytes32',
                                value: 'REALLY_LARGE_VALUE_BIGGER_THAN_BYTES_32_STRING______________________'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_8 = _a.sent();
                    expect(e_8.message).toBe('payload value of type (S) is more than 32 bytes. value length = 68 chars');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it("throws error when payload key is bytes32, and value is malformed: '0x000000000000000000000000000000000000000000000000000000000000000-'", function () { return __awaiter(_this, void 0, void 0, function () {
        var e_9;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'bytes32',
                                value: '0x000000000000000000000000000000000000000000000000000000000000000-'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_9 = _a.sent();
                    expect(e_9.message).toBe('payload value of type (S) is more than 32 bytes. value length = 66 chars');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload key is bytes32, and value is malformed...: 000000000000000000000000000000000000000000000000000000000000000A', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_10;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'test',
                            payload: {
                                key: 'bytes32',
                                value: '000000000000000000000000000000000000000000000000000000000000000A'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_10 = _a.sent();
                    expect(e_10.message).toBe('payload value of type (S) is more than 32 bytes. value length = 64 chars');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throws error when payload.type is to big', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_11;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, transmute_framework_1.Store.writeFSA(store, eventStoreAdapter, relic.web3, accounts[0], {
                            type: 'REALLY_LARGE_VALUE_BIGGER_THAN_BYTES_32_STRING______________________',
                            payload: {
                                key: 'bytes32',
                                value: '000000000000000000000000000000000000000000000000000000000000000A'
                            },
                            meta: {}
                        })];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_11 = _a.sent();
                    expect(e_11.message).toBe('fsa.type (S) is more than 32 bytes. value length = 68 chars');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=bad.events.js.map