"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bs58 = require('bs58');
var web3Utils = require('web3-utils');
var util = require('ethereumjs-util');
exports.toAscii = function (value) {
    return util.toAscii(value).replace(/\u0000/g, '');
};
exports.isValidAddress = function (address) {
    return util.isValidAddress(address);
};
exports.bufferToHex = function (buffer) {
    return util.bufferToHex(buffer);
};
exports.setLengthLeft = function (_value, size) {
    return util.setLengthLeft(_value, size);
};
// https://blog.stakeventures.com/articles/smart-contract-terms
exports.hex2ipfshash = function (hash) {
    return bs58.encode(new Buffer('1220' + hash.slice(2), 'hex'));
};
exports.ipfs2hex = function (ipfshash) {
    return '0x' + new Buffer(bs58.decode(ipfshash).slice(2)).toString('hex');
};
exports.isHex = function (h) {
    return h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)
        ? h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)['index'] === 0
        : false;
};
exports.formatHex = function (h) { return '0x' + h.replace(/^0x/i, ''); }; // assumes valid hex input .. 0x33/33 -> 0x33
exports.hexToNumber = function (h) {
    return web3Utils.hexToNumber(h);
};
exports.toChecksumAddress = function (address) {
    return web3Utils.toChecksumAddress(address);
};
exports.privateKeyHexToAddress = function (privatKeyHex) {
    return util.privateToAddress(privatKeyHex);
};
//# sourceMappingURL=Utils.js.map