"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transmute_framework_1 = require("../transmute-framework");
var bs58 = require('bs58');
var util = require('ethereumjs-util');
var ipfsAdapter = require('transmute-adapter-ipfs');
var nodeStorageAdapter = require('transmute-adapter-node-storage');
var nodeStorageDB = nodeStorageAdapter.getStorage();
var ipfs = ipfsAdapter.getStorage();
exports.getDefaultEventStoreAdapter = function () {
    return new transmute_framework_1.EventStoreAdapter({
        I: {
            keyName: 'multihash',
            adapter: ipfsAdapter,
            db: ipfs,
            readIDFromBytes32: function (bytes32) {
                return bs58.encode(new Buffer('1220' + bytes32.slice(2), 'hex'));
            },
            writeIDToBytes32: function (id) {
                return '0x' + new Buffer(bs58.decode(id).slice(2)).toString('hex');
            }
        },
        N: {
            keyName: 'sha1',
            adapter: nodeStorageAdapter,
            db: nodeStorageDB,
            readIDFromBytes32: function (bytes32) {
                return util.toAscii(bytes32).replace(/\u0000/g, '');
            },
            writeIDToBytes32: function (id) {
                return id;
            }
        }
    });
};
//# sourceMappingURL=getEventStoreAdapter.js.map