"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var getRelic_1 = require("../../../__mocks__/getRelic");
var transmute_framework_1 = require("../../../transmute-framework");
var MarshalledEvents_1 = require("../../../__mocks__/MarshalledEvents");
var WRITE_EVENT_GAS_COST = 4000000;
/**
 * EventStore spec
 */
describe('EventStore', function () {
    var relic;
    var accounts;
    var factory;
    var eventStore;
    var receipt;
    var events;
    var whitelist;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        var factoryEvents;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getRelic_1.getDefaultRelic()];
                case 1:
                    relic = _a.sent();
                    return [4 /*yield*/, relic.getAccounts()];
                case 2:
                    accounts = _a.sent();
                    whitelist = accounts.slice(0, 4);
                    return [4 /*yield*/, transmute_framework_1.EventStoreFactory.New(transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0]), {
                            _multisig: accounts[0]
                        })];
                case 3:
                    factory = _a.sent();
                    return [4 /*yield*/, factory.createEventStore(whitelist, transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[1]))];
                case 4:
                    receipt = _a.sent();
                    events = transmute_framework_1.EventTransformer.getFSAsFromReceipt(receipt);
                    factoryEvents = transmute_framework_1.EventTransformer.filterEventsByMeta(events, 'msgSender', accounts[1]);
                    return [4 /*yield*/, transmute_framework_1.EventStore.At(factoryEvents[0].payload.value)];
                case 5:
                    eventStore = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var readAndWriteEventsTest = function () { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            MarshalledEvents_1.default.map(function (event) {
                it(JSON.stringify(event), function () { return __awaiter(_this, void 0, void 0, function () {
                    var receipt, writtenFSA, eventValues, readFSA;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, eventStore.writeEvent(event.eventType, event.keyType, event.valueType, event.key, event.value, transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0], WRITE_EVENT_GAS_COST))];
                            case 1:
                                receipt = _a.sent();
                                expect(receipt.logs.length).toBe(1);
                                writtenFSA = transmute_framework_1.EventTransformer.esEventToFSA(receipt.logs[0].args);
                                expect(writtenFSA.meta.keyType).toBe(event.keyType);
                                expect(writtenFSA.meta.valueType).toBe(event.valueType);
                                return [4 /*yield*/, eventStore.readEvent(0, transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0]))];
                            case 2:
                                eventValues = _a.sent();
                                readFSA = transmute_framework_1.EventTransformer.arrayToFSA(eventValues);
                                expect(writtenFSA.meta.keyType).toBe(event.keyType);
                                expect(writtenFSA.meta.valueType).toBe(event.valueType);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            return [2 /*return*/];
        });
    }); };
    describe('eventStore read and write', function () {
        readAndWriteEventsTest();
    });
    it('eventCount', function () { return __awaiter(_this, void 0, void 0, function () {
        var factoryEvents, eventCount;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transmute_framework_1.EventStoreFactory.New(transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0]), {
                        _multisig: accounts[0]
                    })
                    // create a new eventStore
                ];
                case 1:
                    // create a new factory
                    factory = _a.sent();
                    return [4 /*yield*/, factory.createEventStore(whitelist, transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[1]))];
                case 2:
                    // create a new eventStore
                    receipt = _a.sent();
                    events = transmute_framework_1.EventTransformer.getFSAsFromReceipt(receipt);
                    factoryEvents = transmute_framework_1.EventTransformer.filterEventsByMeta(events, 'msgSender', accounts[1]);
                    return [4 /*yield*/, transmute_framework_1.EventStore.At(factoryEvents[0].payload.value)];
                case 3:
                    eventStore = _a.sent();
                    return [4 /*yield*/, eventStore.eventCount()];
                case 4:
                    eventCount = _a.sent();
                    expect(eventCount.toNumber()).toBe(3);
                    return [2 /*return*/];
            }
        });
    }); });
    it('getInternalEventTypes', function () { return __awaiter(_this, void 0, void 0, function () {
        var factoryEvents, types;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transmute_framework_1.EventStoreFactory.New(transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0]), {
                        _multisig: accounts[0]
                    })
                    // create a new eventStore
                ];
                case 1:
                    // create a new factory
                    factory = _a.sent();
                    return [4 /*yield*/, factory.createEventStore(whitelist, transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[1]))];
                case 2:
                    // create a new eventStore
                    receipt = _a.sent();
                    events = transmute_framework_1.EventTransformer.getFSAsFromReceipt(receipt);
                    factoryEvents = transmute_framework_1.EventTransformer.filterEventsByMeta(events, 'msgSender', accounts[1]);
                    return [4 /*yield*/, transmute_framework_1.EventStore.At(factoryEvents[0].payload.value)];
                case 3:
                    eventStore = _a.sent();
                    return [4 /*yield*/, eventStore.getInternalEventTypes()];
                case 4:
                    types = (_a.sent()).map(transmute_framework_1.Utils.toAscii);
                    expect(types).toEqual(transmute_framework_1.InternalEventTypes.STORE);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=eventstore.tests.js.map