"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var getRelic_1 = require("../__mocks__/getRelic");
var transmute_framework_1 = require("../transmute-framework");
/**
 * contract tests
 */
describe('contract tests', function () {
    var accounts;
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
        var relic;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    relic = getRelic_1.getDefaultRelic();
                    return [4 /*yield*/, relic.getAccounts()];
                case 1:
                    accounts = _a.sent();
                    transmute_framework_1.W3.Default = relic.web3;
                    return [2 /*return*/];
            }
        });
    }); });
    it('can create a contract', function () { return __awaiter(_this, void 0, void 0, function () {
        var packageManagerContract, countAsBigNum, eventValues, event;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transmute_framework_1.PackageManager.New(transmute_framework_1.W3.TC.txParamsDefaultDeploy(accounts[0]), {
                        _multisig: accounts[0]
                    })];
                case 1:
                    packageManagerContract = _a.sent();
                    return [4 /*yield*/, packageManagerContract.eventCount()];
                case 2:
                    countAsBigNum = _a.sent();
                    expect(countAsBigNum.toNumber()).toBe(1);
                    return [4 /*yield*/, packageManagerContract.readEvent(0)];
                case 3:
                    eventValues = _a.sent();
                    event = transmute_framework_1.EventTransformer.arrayToFSA(eventValues);
                    expect(event.type).toBe('NEW_OWNER');
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=contract.tests.js.map