"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var web3_1 = require("web3");
var ProviderEngine = require('web3-provider-engine');
var RpcSubprovider = require('web3-provider-engine/subproviders/rpc.js');
var WalletSubprovider = require('web3-provider-engine/subproviders/wallet.js');
var getWeb3_1 = require("../__mocks__/getWeb3");
var RPC_HOST = 'http://localhost:8545';
/**
 * web3 tests
 */
describe('web3 tests', function () {
    it('vanilla web3 provider', function () { return __awaiter(_this, void 0, void 0, function () {
        var web3, accounts;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    web3 = new web3_1.default(new web3_1.default.providers.HttpProvider(RPC_HOST));
                    return [4 /*yield*/, getWeb3_1.getAccounts(web3)];
                case 1:
                    accounts = _a.sent();
                    expect(accounts.length).toBe(10);
                    return [2 /*return*/];
            }
        });
    }); });
    it('supports provider engine default', function () { return __awaiter(_this, void 0, void 0, function () {
        var web3, accounts;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    web3 = getWeb3_1.getDefaultWeb3().web3;
                    return [4 /*yield*/, getWeb3_1.getAccounts(web3)];
                case 1:
                    accounts = _a.sent();
                    expect(accounts.length).toBe(10);
                    return [2 /*return*/];
            }
        });
    }); });
    it('supports provider engine wallet from menumonic', function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, web3, address, accounts;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = getWeb3_1.getWeb3FromWalletWithMneumonic(), web3 = _a.web3, address = _a.address;
                    return [4 /*yield*/, getWeb3_1.getAccounts(web3)];
                case 1:
                    accounts = _b.sent();
                    expect(accounts.length).toBe(1);
                    expect(accounts[0]).toBe(web3.utils.toChecksumAddress(address));
                    return [2 /*return*/];
            }
        });
    }); });
    it('supports provider engine wallet from sodium private key', function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, web3, address, accounts;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, getWeb3_1.getWeb3FromWalletWithPrivateKey()];
                case 1:
                    _a = _b.sent(), web3 = _a.web3, address = _a.address;
                    return [4 /*yield*/, getWeb3_1.getAccounts(web3)];
                case 2:
                    accounts = _b.sent();
                    expect(accounts.length).toBe(1);
                    expect(accounts[0]).toBe(web3.utils.toChecksumAddress(address));
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=web3.tests.js.map