import { Relic, EventStoreAdapter, IReadModelAdapter, PackageManager, IFSA, ReadModel } from '../transmute-framework';
export default class PackageService {
    relic: Relic;
    packageManager: PackageManager;
    eventStoreAdapter: EventStoreAdapter;
    readModelAdapter: IReadModelAdapter;
    readModel: ReadModel;
    constructor(relic: Relic, packageManager: PackageManager, eventStoreAdapter: EventStoreAdapter, readModelAdapter: IReadModelAdapter);
    requireLatestReadModel: () => Promise<void>;
    publishPackage: (multihash: string, name: string, fromAddress: string) => Promise<IFSA>;
    deletePackage: (multihash: string, fromAddress: string) => Promise<IFSA>;
    getReadModel: () => Promise<ReadModel>;
}
