import { IFSA, ITransmuteStoreAdapter, ITransmuteStoreAdapterMap, EventStore } from '../../transmute-framework';
export declare class EventStoreAdapter {
    mapper: ITransmuteStoreAdapterMap;
    mapperKeys: string[];
    eventMap: any;
    constructor(mapper: ITransmuteStoreAdapterMap);
    convertFSAPayload: (fsa: IFSA) => Promise<{
        payload: {
            key: string;
            value: string;
        };
        type: string;
        meta: any;
    }>;
    getEsEventParamsFromFSA: (event: IFSA) => Promise<any>;
    writeFSA: (store: EventStore, fromAddress: string, event: IFSA) => Promise<IFSA>;
    throwOnAdapterTypeCollision: () => void;
    throwOnAdapterTypeConversionUndefined: () => void;
    getItem: (adapter: ITransmuteStoreAdapter, db: any, key: string) => Promise<any>;
    setItem: (adapter: ITransmuteStoreAdapter, db: any, value: any) => Promise<string>;
    isPayloadKeySizeSafe: (keyValue: string, keyType: string) => boolean;
    isPayloadMisleading: (event: IFSA) => void;
    convertValueToType: (_valueType: any, _value: any) => Promise<any>;
    marshal: (_eventType: any, _keyType: any, _valueType: any, _key: any, _value: any) => Promise<{
        eventType: any;
        keyType: any;
        valueType: any;
        key: any;
        value: any;
    }>;
    extractEventsFromLogs: (logs: any[]) => Promise<any[]>;
}
