import { IFSA, IEsEvent } from './EventTypes';
export declare enum FSATypes {
    Native = 0,
    SimpleKeyValue = 1,
    Adapter = 2,
}
export declare const getFSAType: (fsa: IFSA) => FSATypes;
export declare const payloadKeyToKeyType: {
    [key: string]: string;
};
export declare const isNativeEvent: (fsa: IFSA) => boolean;
export declare const isSimpleStringKeyValue: (fsa: IFSA) => boolean;
export declare const isAdapterEvent: (fsa: IFSA) => boolean;
export declare const getFSAsFromReceipt: (receipt: any) => any[];
export declare const filterEventsByMeta: (events: IFSA[], prop: any, propValue: any) => any[];
export declare const valuesToEsEvent: (Id: any, TxOrigin: any, MsgSender: any, Created: any, EventType: any, KeyType: any, ValueType: any, Key: any, Value: any) => IEsEvent;
export declare const getFSAFromEsEventWithPartial: (esEvent: IEsEvent, partialFSA: IFSA) => {
    payload: any;
    type: string;
    meta: any;
};
export declare const esEventToFSA: (esEvent: IEsEvent) => IFSA;
export declare const arrayToFSA: (values: any) => IFSA;
