import { W3, EventStore, EventStoreAdapter, IFSA } from '../transmute-framework';
export declare const GAS_COSTS: {
    WRITE_EVENT: number;
};
export declare namespace Store {
    const get: (address: string, web3: W3) => Promise<EventStore>;
    /**
     * Store eventCount
     */
    const eventCount: (store: EventStore) => Promise<number>;
    const transferOwnership: (store: EventStore, from: string, to: string) => Promise<any[]>;
    /**
     * Store readFSA
     */
    const readFSA: (store: EventStore, eventStoreAdapter: EventStoreAdapter, web3: any, eventId: number) => Promise<any>;
    /**
     * Store writeFSA
     */
    const writeFSA: (store: EventStore, eventStoreAdapter: EventStoreAdapter, web3: any, fromAddress: string, event: IFSA) => Promise<IFSA>;
    const writeFSAs: (store: EventStore, eventStoreAdapter: EventStoreAdapter, web3: any, fromAddress: string, events: IFSA[]) => Promise<IFSA[]>;
    const readFSAs: (store: EventStore, eventStoreAdapter: EventStoreAdapter, web3: any, eventIndex?: number) => Promise<IFSA[]>;
}
