import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * AddressSetSpec API
 */
export declare class AddressSetSpec extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<AddressSetSpec>;
    static At(address: string | object, w3?: W3): Promise<AddressSetSpec>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    add: ((value: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (value: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (value: string) => Promise<string>;
    } & {
        estimateGas: (value: string) => Promise<number>;
    };
    getValues(txParams?: W3.TC.TxParams): Promise<string[]>;
    remove: ((value: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (value: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (value: string) => Promise<string>;
    } & {
        estimateGas: (value: string) => Promise<number>;
    };
    set: ((index: number | BigNumber, value: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (index: number | BigNumber, value: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (index: number | BigNumber, value: string) => Promise<string>;
    } & {
        estimateGas: (index: number | BigNumber, value: string) => Promise<number>;
    };
    first(txParams?: W3.TC.TxParams): Promise<string>;
    last(txParams?: W3.TC.TxParams): Promise<string>;
    contains(value: string, txParams?: W3.TC.TxParams): Promise<boolean>;
    pop: ((index: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (index: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (index: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (index: number | BigNumber) => Promise<number>;
    };
    destroy: ((txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    lastRemove(txParams?: W3.TC.TxParams): Promise<boolean>;
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    lastPop(txParams?: W3.TC.TxParams): Promise<string>;
    size(txParams?: W3.TC.TxParams): Promise<BigNumber>;
    get(index: BigNumber | number, txParams?: W3.TC.TxParams): Promise<string>;
    transferOwnership: ((newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
    destroyAndSend: ((_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_recipient: string) => Promise<string>;
    } & {
        estimateGas: (_recipient: string) => Promise<number>;
    };
    indexOf(value: string, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    lastAdd(txParams?: W3.TC.TxParams): Promise<boolean>;
}
