import { W3, SoltsiceContract } from 'soltsice';
/**
 * Destructible API
 */
export declare class Destructible extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<Destructible>;
    static At(address: string | object, w3?: W3): Promise<Destructible>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    destroy: ((txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    transferOwnership: ((newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
    destroyAndSend: ((_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_recipient: string) => Promise<string>;
    } & {
        estimateGas: (_recipient: string) => Promise<number>;
    };
}
