import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * EventStore API
 */
export declare class EventStore extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<EventStore>;
    static At(address: string | object, w3?: W3): Promise<EventStore>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    getInternalEventTypes(txParams?: W3.TC.TxParams): Promise<string>;
    recycle: ((txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    writeEvent: ((_eventType: string, _keyType: string, _valueType: string, _key: string, _value: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_eventType: string, _keyType: string, _valueType: string, _key: string, _value: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_eventType: string, _keyType: string, _valueType: string, _key: string, _value: string) => Promise<string>;
    } & {
        estimateGas: (_eventType: string, _keyType: string, _valueType: string, _key: string, _value: string) => Promise<number>;
    };
    eventCount(txParams?: W3.TC.TxParams): Promise<BigNumber>;
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    recycleAndSend: ((_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_recipient: string) => Promise<string>;
    } & {
        estimateGas: (_recipient: string) => Promise<number>;
    };
    getWhitelist(txParams?: W3.TC.TxParams): Promise<string[]>;
    readEvent(_eventId: BigNumber | number, txParams?: W3.TC.TxParams): Promise<any>;
    transferOwnership: ((newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
    setWhitelist: ((_whitelist: string[], txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_whitelist: string[], txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_whitelist: string[]) => Promise<string>;
    } & {
        estimateGas: (_whitelist: string[]) => Promise<number>;
    };
}
