import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * EventStoreFactory API
 */
export declare class EventStoreFactory extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<EventStoreFactory>;
    static At(address: string | object, w3?: W3): Promise<EventStoreFactory>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    getInternalEventTypes(txParams?: W3.TC.TxParams): Promise<string>;
    recycle: ((txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    eventCount(txParams?: W3.TC.TxParams): Promise<BigNumber>;
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    getEventStores(txParams?: W3.TC.TxParams): Promise<string[]>;
    recycleAndSend: ((_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_recipient: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_recipient: string) => Promise<string>;
    } & {
        estimateGas: (_recipient: string) => Promise<number>;
    };
    readEvent(_eventId: BigNumber | number, txParams?: W3.TC.TxParams): Promise<any>;
    transferOwnership: ((_newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_newOwner: string) => Promise<string>;
    } & {
        estimateGas: (_newOwner: string) => Promise<number>;
    };
    createEventStore: ((_whitelist: string[], txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (_whitelist: string[], txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (_whitelist: string[]) => Promise<string>;
    } & {
        estimateGas: (_whitelist: string[]) => Promise<number>;
    };
}
