import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * EventStoreLib API
 */
export declare class EventStoreLib extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<EventStoreLib>;
    static At(address: string | object, w3?: W3): Promise<EventStoreLib>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    writeEvent: ((self: any, _eventType: string, _keyType: string, _valueType: string, _key: string, _value: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, _eventType: string, _keyType: string, _valueType: string, _key: string, _value: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, _eventType: string, _keyType: string, _valueType: string, _key: string, _value: string) => Promise<string>;
    } & {
        estimateGas: (self: any, _eventType: string, _keyType: string, _valueType: string, _key: string, _value: string) => Promise<number>;
    };
    readEvent(self: any, _eventId: BigNumber | number, txParams?: W3.TC.TxParams): Promise<any>;
}
