import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * Migrations API
 */
export declare class Migrations extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<Migrations>;
    static At(address: string | object, w3?: W3): Promise<Migrations>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    upgrade: ((new_address: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (new_address: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (new_address: string) => Promise<string>;
    } & {
        estimateGas: (new_address: string) => Promise<number>;
    };
    last_completed_migration(txParams?: W3.TC.TxParams): Promise<BigNumber>;
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    setCompleted: ((completed: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (completed: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (completed: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (completed: number | BigNumber) => Promise<number>;
    };
}
