import { W3, SoltsiceContract } from 'soltsice';
/**
 * Ownable API
 */
export declare class Ownable extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<Ownable>;
    static At(address: string | object, w3?: W3): Promise<Ownable>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    owner(txParams?: W3.TC.TxParams): Promise<string>;
    transferOwnership: ((newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (newOwner: string, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
}
