import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from 'soltsice';
/**
 * UIntSetLib API
 */
export declare class UIntSetLib extends SoltsiceContract {
    static readonly Artifacts: any;
    static readonly BytecodeHash: string | undefined;
    static New(deploymentParams: W3.TC.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]): Promise<UIntSetLib>;
    static At(address: string | object, w3?: W3): Promise<UIntSetLib>;
    protected constructor(deploymentParams: string | W3.TC.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    replace: ((self: any, old: number | BigNumber, nu: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, old: number | BigNumber, nu: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, old: number | BigNumber, nu: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (self: any, old: number | BigNumber, nu: number | BigNumber) => Promise<number>;
    };
    add: ((self: any, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, value: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (self: any, value: number | BigNumber) => Promise<number>;
    };
    indexOf(self: any, value: BigNumber | number, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    remove: ((self: any, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, value: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (self: any, value: number | BigNumber) => Promise<number>;
    };
    contains(self: any, value: BigNumber | number, txParams?: W3.TC.TxParams): Promise<boolean>;
    size(self: any, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    get(self: any, index: BigNumber | number, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    last(self: any, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    pop: ((self: any, index: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, index: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, index: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (self: any, index: number | BigNumber) => Promise<number>;
    };
    first(self: any, txParams?: W3.TC.TxParams): Promise<BigNumber>;
    set: ((self: any, index: number | BigNumber, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<W3.TC.TransactionResult>) & {
        sendTransaction: (self: any, index: number | BigNumber, value: number | BigNumber, txParams?: W3.TC.TxParams | undefined) => Promise<string>;
    } & {
        data: (self: any, index: number | BigNumber, value: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (self: any, index: number | BigNumber, value: number | BigNumber) => Promise<number>;
    };
}
