(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('soltsice')) :
	typeof define === 'function' && define.amd ? define(['exports', 'soltsice'], factory) :
	(factory((global.transmuteFramework = {}),global.soltsice));
}(this, (function (exports,soltsice) { 'use strict';

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Relic = /** @class */ (function () {
    function Relic(web3) {
        var _this = this;
        this.getAccounts = function () {
            return new Promise(function (resolve, reject) {
                _this.web3.eth.getAccounts(function (err, accounts) {
                    if (err) {
                        reject(err);
                    }
                    resolve(accounts);
                });
            });
        };
        soltsice.W3.Default = this.web3 = web3;
    }
    Relic.prototype.getBalance = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        
                        _this.web3.eth.getBalance(address, function (err, balance) {
                            if (err) {
                                reject(err);
                            }
                            resolve(parseInt(balance, 10));
                        });
                    })];
            });
        });
    };
    Relic.prototype.sendWei = function (fromAddress, toAddress, amountWei) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        
                        _this.web3.eth.sendTransaction({
                            from: fromAddress,
                            to: toAddress,
                            value: amountWei
                        }, function (err, txhash) {
                            if (err) {
                                reject(err);
                            }
                            resolve(txhash);
                        });
                    })];
            });
        });
    };
    return Relic;
}());

var bs58 = require('bs58');
var web3Utils = require('web3-utils');
var util = require('ethereumjs-util');
var toAscii = function (value) {
    return util.toAscii(value).replace(/\u0000/g, '');
};
var isValidAddress = function (address) {
    return util.isValidAddress(address);
};
var bufferToHex = function (buffer) {
    return util.bufferToHex(buffer);
};
var setLengthLeft = function (_value, size) {
    return util.setLengthLeft(_value, size);
};
// https://blog.stakeventures.com/articles/smart-contract-terms
var hex2ipfshash = function (hash) {
    return bs58.encode(new Buffer('1220' + hash.slice(2), 'hex'));
};
var ipfs2hex = function (ipfshash) {
    return '0x' + new Buffer(bs58.decode(ipfshash).slice(2)).toString('hex');
};
var isHex = function (h) {
    return h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)
        ? h.replace(/^0x/i, '').match(/[0-9A-Fa-f]+$/)['index'] === 0
        : false;
};
var formatHex = function (h) { return '0x' + h.replace(/^0x/i, ''); }; // assumes valid hex input .. 0x33/33 -> 0x33
var hexToNumber = function (h) {
    return web3Utils.hexToNumber(h);
};
var toChecksumAddress = function (address) {
    return web3Utils.toChecksumAddress(address);
};
var privateKeyHexToAddress = function (privatKeyHex) {
    return util.privateToAddress(privatKeyHex);
};



var index = Object.freeze({
	toAscii: toAscii,
	isValidAddress: isValidAddress,
	bufferToHex: bufferToHex,
	setLengthLeft: setLengthLeft,
	hex2ipfshash: hex2ipfshash,
	ipfs2hex: ipfs2hex,
	isHex: isHex,
	formatHex: formatHex,
	hexToNumber: hexToNumber,
	toChecksumAddress: toChecksumAddress,
	privateKeyHexToAddress: privateKeyHexToAddress
});

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$1 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$1 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * AddressSetLib API
 */
var AddressSetLib = /** @class */ (function (_super) {
    __extends(AddressSetLib, _super);
    function AddressSetLib(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, AddressSetLib.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(self, index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(self, index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(self, index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(self, index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.replace = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, old, nu, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.replace(self, old, nu, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, old, nu, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.sendTransaction(self, old, nu, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.replace.request(self, old, nu).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.estimateGas(self, old, nu).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(self, index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(self, index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(self, index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(self, index).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(AddressSetLib, "Artifacts", {
        get: function () { return require('./contracts/AddressSetLib.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressSetLib, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = AddressSetLib.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    AddressSetLib.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$1(this, void 0, void 0, function () {
            var contract;
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new AddressSetLib(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    AddressSetLib.At = function (address, w3) {
        return __awaiter$1(this, void 0, void 0, function () {
            var contract;
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new AddressSetLib(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.size = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.indexOf = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.last = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.get = function (self, index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(self, index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.contains = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetLib.prototype.first = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return AddressSetLib;
}(soltsice.SoltsiceContract));

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$2 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$2 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * AddressSetSpec API
 */
var AddressSetSpec = /** @class */ (function (_super) {
    __extends$1(AddressSetSpec, _super);
    function AddressSetSpec(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, AddressSetSpec.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(index).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroy = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroy(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroy.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroyAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroyAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroyAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(AddressSetSpec, "Artifacts", {
        get: function () { return require('./contracts/AddressSetSpec.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressSetSpec, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = AddressSetSpec.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    AddressSetSpec.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$2(this, void 0, void 0, function () {
            var contract;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new AddressSetSpec(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    AddressSetSpec.At = function (address, w3) {
        return __awaiter$2(this, void 0, void 0, function () {
            var contract;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new AddressSetSpec(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.getValues = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getValues
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.first = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.last = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.contains = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.lastRemove = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastRemove
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.lastPop = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastPop
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.size = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.get = function (index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.indexOf = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    AddressSetSpec.prototype.lastAdd = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastAdd
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return AddressSetSpec;
}(soltsice.SoltsiceContract));

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$3 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$3 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Bytes32SetLib API
 */
var Bytes32SetLib = /** @class */ (function (_super) {
    __extends$2(Bytes32SetLib, _super);
    function Bytes32SetLib(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, Bytes32SetLib.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(self, index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(self, index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(self, index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(self, index).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(self, index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(self, index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(self, index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(self, index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.replace = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, old, nu, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.replace(self, old, nu, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, old, nu, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.sendTransaction(self, old, nu, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.replace.request(self, old, nu).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.estimateGas(self, old, nu).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(Bytes32SetLib, "Artifacts", {
        get: function () { return require('./contracts/Bytes32SetLib.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bytes32SetLib, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = Bytes32SetLib.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    Bytes32SetLib.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$3(this, void 0, void 0, function () {
            var contract;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Bytes32SetLib(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    Bytes32SetLib.At = function (address, w3) {
        return __awaiter$3(this, void 0, void 0, function () {
            var contract;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Bytes32SetLib(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.contains = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.size = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.last = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.get = function (self, index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(self, index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.indexOf = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetLib.prototype.first = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return Bytes32SetLib;
}(soltsice.SoltsiceContract));

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$4 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$4 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Bytes32SetSpec API
 */
var Bytes32SetSpec = /** @class */ (function (_super) {
    __extends$3(Bytes32SetSpec, _super);
    function Bytes32SetSpec(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, Bytes32SetSpec.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(index).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroy = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroy(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroy.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroyAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroyAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroyAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(Bytes32SetSpec, "Artifacts", {
        get: function () { return require('./contracts/Bytes32SetSpec.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Bytes32SetSpec, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = Bytes32SetSpec.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    Bytes32SetSpec.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$4(this, void 0, void 0, function () {
            var contract;
            return __generator$4(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Bytes32SetSpec(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    Bytes32SetSpec.At = function (address, w3) {
        return __awaiter$4(this, void 0, void 0, function () {
            var contract;
            return __generator$4(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Bytes32SetSpec(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.getValues = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getValues
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.contains = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.first = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.last = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.indexOf = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.lastRemove = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastRemove
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.lastPop = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastPop
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.size = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.get = function (index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Bytes32SetSpec.prototype.lastAdd = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastAdd
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return Bytes32SetSpec;
}(soltsice.SoltsiceContract));

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$5 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$5 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Destructible API
 */
var Destructible = /** @class */ (function (_super) {
    __extends$4(Destructible, _super);
    function Destructible(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, Destructible.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.destroy = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroy(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroy.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroyAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroyAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroyAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(Destructible, "Artifacts", {
        get: function () { return require('./contracts/Destructible.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Destructible, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = Destructible.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    Destructible.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$5(this, void 0, void 0, function () {
            var contract;
            return __generator$5(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Destructible(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    Destructible.At = function (address, w3) {
        return __awaiter$5(this, void 0, void 0, function () {
            var contract;
            return __generator$5(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Destructible(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Destructible.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return Destructible;
}(soltsice.SoltsiceContract));

var __extends$5 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$6 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$6 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * EventStore API
 */
var EventStore = /** @class */ (function (_super) {
    __extends$5(EventStore, _super);
    function EventStore(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, EventStore.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.recycle = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycle(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycle.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.writeEvent = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_eventType, _keyType, _valueType, _key, _value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.writeEvent(_eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_eventType, _keyType, _valueType, _key, _value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.sendTransaction(_eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.writeEvent.request(_eventType, _keyType, _valueType, _key, _value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.estimateGas(_eventType, _keyType, _valueType, _key, _value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.recycleAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycleAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycleAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.setWhitelist = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_whitelist, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.setWhitelist(_whitelist, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_whitelist, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setWhitelist.sendTransaction(_whitelist, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.setWhitelist.request(_whitelist).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setWhitelist.estimateGas(_whitelist).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(EventStore, "Artifacts", {
        get: function () { return require('./contracts/EventStore.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventStore, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = EventStore.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    EventStore.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$6(this, void 0, void 0, function () {
            var contract;
            return __generator$6(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStore(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    EventStore.At = function (address, w3) {
        return __awaiter$6(this, void 0, void 0, function () {
            var contract;
            return __generator$6(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStore(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStore.prototype.getInternalEventTypes = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getInternalEventTypes
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStore.prototype.eventCount = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.eventCount
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStore.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStore.prototype.getWhitelist = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getWhitelist
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStore.prototype.readEvent = function (_eventId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.readEvent
                .call(_eventId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return EventStore;
}(soltsice.SoltsiceContract));

var __extends$6 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$7 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$7 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * EventStoreFactory API
 */
var EventStoreFactory = /** @class */ (function (_super) {
    __extends$6(EventStoreFactory, _super);
    function EventStoreFactory(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, EventStoreFactory.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.recycle = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycle(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycle.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.recycleAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycleAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycleAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(_newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(_newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(_newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(_newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.createEventStore = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_whitelist, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.createEventStore(_whitelist, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_whitelist, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.createEventStore.sendTransaction(_whitelist, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.createEventStore.request(_whitelist).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    _this._instance.createEventStore.estimateGas(_whitelist).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(EventStoreFactory, "Artifacts", {
        get: function () { return require('./contracts/EventStoreFactory.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventStoreFactory, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = EventStoreFactory.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    EventStoreFactory.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$7(this, void 0, void 0, function () {
            var contract;
            return __generator$7(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStoreFactory(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    EventStoreFactory.At = function (address, w3) {
        return __awaiter$7(this, void 0, void 0, function () {
            var contract;
            return __generator$7(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStoreFactory(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreFactory.prototype.getInternalEventTypes = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getInternalEventTypes
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreFactory.prototype.eventCount = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.eventCount
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreFactory.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreFactory.prototype.getEventStores = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getEventStores
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreFactory.prototype.readEvent = function (_eventId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.readEvent
                .call(_eventId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return EventStoreFactory;
}(soltsice.SoltsiceContract));

var __extends$7 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$8 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$8 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * EventStoreLib API
 */
var EventStoreLib = /** @class */ (function (_super) {
    __extends$7(EventStoreLib, _super);
    function EventStoreLib(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, EventStoreLib.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.writeEvent = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, _eventType, _keyType, _valueType, _key, _value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.writeEvent(self, _eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, _eventType, _keyType, _valueType, _key, _value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.sendTransaction(self, _eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, _eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.writeEvent.request(self, _eventType, _keyType, _valueType, _key, _value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, _eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.estimateGas(self, _eventType, _keyType, _valueType, _key, _value).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(EventStoreLib, "Artifacts", {
        get: function () { return require('./contracts/EventStoreLib.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventStoreLib, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = EventStoreLib.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    EventStoreLib.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$8(this, void 0, void 0, function () {
            var contract;
            return __generator$8(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStoreLib(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    EventStoreLib.At = function (address, w3) {
        return __awaiter$8(this, void 0, void 0, function () {
            var contract;
            return __generator$8(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new EventStoreLib(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    EventStoreLib.prototype.readEvent = function (self, _eventId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.readEvent
                .call(self, _eventId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return EventStoreLib;
}(soltsice.SoltsiceContract));

var __extends$8 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$9 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$9 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Migrations API
 */
var Migrations = /** @class */ (function (_super) {
    __extends$8(Migrations, _super);
    function Migrations(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, Migrations.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.upgrade = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (new_address, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.upgrade(new_address, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (new_address, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.upgrade.sendTransaction(new_address, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (new_address) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.upgrade.request(new_address).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (new_address) {
                return new Promise(function (resolve, reject) {
                    _this._instance.upgrade.estimateGas(new_address).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.setCompleted = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (completed, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.setCompleted(completed, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (completed, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setCompleted.sendTransaction(completed, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (completed) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.setCompleted.request(completed).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (completed) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setCompleted.estimateGas(completed).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(Migrations, "Artifacts", {
        get: function () { return require('./contracts/Migrations.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Migrations, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = Migrations.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    Migrations.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$9(this, void 0, void 0, function () {
            var contract;
            return __generator$9(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Migrations(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    Migrations.At = function (address, w3) {
        return __awaiter$9(this, void 0, void 0, function () {
            var contract;
            return __generator$9(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Migrations(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Migrations.prototype.last_completed_migration = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last_completed_migration
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Migrations.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return Migrations;
}(soltsice.SoltsiceContract));

var __extends$9 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$10 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$10 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Ownable API
 */
var Ownable = /** @class */ (function (_super) {
    __extends$9(Ownable, _super);
    function Ownable(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, Ownable.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(Ownable, "Artifacts", {
        get: function () { return require('./contracts/Ownable.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Ownable, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = Ownable.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    Ownable.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$10(this, void 0, void 0, function () {
            var contract;
            return __generator$10(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Ownable(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    Ownable.At = function (address, w3) {
        return __awaiter$10(this, void 0, void 0, function () {
            var contract;
            return __generator$10(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new Ownable(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    Ownable.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return Ownable;
}(soltsice.SoltsiceContract));

var __extends$10 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$11 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$11 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * PackageManager API
 */
var PackageManager = /** @class */ (function (_super) {
    __extends$10(PackageManager, _super);
    function PackageManager(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, PackageManager.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.recycle = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycle(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycle.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycle.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.writeEvent = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_eventType, _keyType, _valueType, _key, _value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.writeEvent(_eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_eventType, _keyType, _valueType, _key, _value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.sendTransaction(_eventType, _keyType, _valueType, _key, _value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.writeEvent.request(_eventType, _keyType, _valueType, _key, _value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_eventType, _keyType, _valueType, _key, _value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.writeEvent.estimateGas(_eventType, _keyType, _valueType, _key, _value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.recycleAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.recycleAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.recycleAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.recycleAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.setWhitelist = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_whitelist, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.setWhitelist(_whitelist, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_whitelist, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setWhitelist.sendTransaction(_whitelist, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.setWhitelist.request(_whitelist).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_whitelist) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setWhitelist.estimateGas(_whitelist).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(PackageManager, "Artifacts", {
        get: function () { return require('./contracts/PackageManager.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PackageManager, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = PackageManager.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    PackageManager.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$11(this, void 0, void 0, function () {
            var contract;
            return __generator$11(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new PackageManager(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    PackageManager.At = function (address, w3) {
        return __awaiter$11(this, void 0, void 0, function () {
            var contract;
            return __generator$11(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new PackageManager(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    PackageManager.prototype.getInternalEventTypes = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getInternalEventTypes
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    PackageManager.prototype.eventCount = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.eventCount
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    PackageManager.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    PackageManager.prototype.getWhitelist = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getWhitelist
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    PackageManager.prototype.readEvent = function (_eventId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.readEvent
                .call(_eventId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return PackageManager;
}(soltsice.SoltsiceContract));

var __extends$11 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$12 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$12 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * StringUtils API
 */
var StringUtils = /** @class */ (function (_super) {
    __extends$11(StringUtils, _super);
    function StringUtils(deploymentParams, ctorParams, w3, link) {
        // tslint:disable-next-line:max-line-length
        return _super.call(this, w3, StringUtils.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
    }
    Object.defineProperty(StringUtils, "Artifacts", {
        get: function () { return require('./contracts/StringUtils.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StringUtils, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = StringUtils.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    StringUtils.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$12(this, void 0, void 0, function () {
            var contract;
            return __generator$12(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new StringUtils(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    StringUtils.At = function (address, w3) {
        return __awaiter$12(this, void 0, void 0, function () {
            var contract;
            return __generator$12(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new StringUtils(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    /*
        Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    StringUtils.prototype.bytesToUInt = function (v, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.bytesToUInt
                .call(v, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    StringUtils.prototype.uintToBytes = function (v, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.uintToBytes
                .call(v, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return StringUtils;
}(soltsice.SoltsiceContract));

var __extends$12 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$13 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$13 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * UIntSetLib API
 */
var UIntSetLib = /** @class */ (function (_super) {
    __extends$12(UIntSetLib, _super);
    function UIntSetLib(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, UIntSetLib.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.replace = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, old, nu, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.replace(self, old, nu, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, old, nu, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.sendTransaction(self, old, nu, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.replace.request(self, old, nu).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, old, nu) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replace.estimateGas(self, old, nu).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(self, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(self, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(self, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(self, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(self, index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(self, index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(self, index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(self, index).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (self, index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(self, index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (self, index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(self, index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(self, index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (self, index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(self, index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(UIntSetLib, "Artifacts", {
        get: function () { return require('./contracts/UIntSetLib.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UIntSetLib, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = UIntSetLib.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    UIntSetLib.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$13(this, void 0, void 0, function () {
            var contract;
            return __generator$13(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new UIntSetLib(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    UIntSetLib.At = function (address, w3) {
        return __awaiter$13(this, void 0, void 0, function () {
            var contract;
            return __generator$13(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new UIntSetLib(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.indexOf = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.contains = function (self, value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(self, value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.size = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.get = function (self, index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(self, index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.last = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetLib.prototype.first = function (self, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(self, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return UIntSetLib;
}(soltsice.SoltsiceContract));

var __extends$13 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$14 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$14 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * UIntSetSpec API
 */
var UIntSetSpec = /** @class */ (function (_super) {
    __extends$13(UIntSetSpec, _super);
    function UIntSetSpec(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, UIntSetSpec.Artifacts, ctorParams ? [] : [], deploymentParams, link) || this;
        /*
            Contract methods
        */
        // tslint:disable-next-line:member-ordering
        _this.add = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.add(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.add.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.add.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.set = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.set(index, value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.sendTransaction(index, value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index, value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.set.request(index, value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index, value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.set.estimateGas(index, value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.remove = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (value, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.remove(value, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (value, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.sendTransaction(value, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (value) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.remove.request(value).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (value) {
                return new Promise(function (resolve, reject) {
                    _this._instance.remove.estimateGas(value).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.pop = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (index, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.pop(index, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (index, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.sendTransaction(index, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (index) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.pop.request(index).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (index) {
                return new Promise(function (resolve, reject) {
                    _this._instance.pop.estimateGas(index).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroy = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroy(txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroy.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroy.estimateGas().then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.destroyAndSend = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_recipient, txParams) {
            return new Promise(function (resolve, reject) {
                _this._instance.destroyAndSend(_recipient, txParams || _this._sendParams)
                    .then(function (res) { return resolve(res); })
                    .catch(function (err) { return reject(err); });
            });
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: function (_recipient, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.sendTransaction(_recipient, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.destroyAndSend.request(_recipient).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_recipient) {
                return new Promise(function (resolve, reject) {
                    _this._instance.destroyAndSend.estimateGas(_recipient).then(function (g) { return resolve(g); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(UIntSetSpec, "Artifacts", {
        get: function () { return require('./contracts/UIntSetSpec.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UIntSetSpec, "BytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = UIntSetSpec.Artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = soltsice.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    UIntSetSpec.New = function (deploymentParams, ctorParams, w3, link) {
        return __awaiter$14(this, void 0, void 0, function () {
            var contract;
            return __generator$14(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new UIntSetSpec(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    UIntSetSpec.At = function (address, w3) {
        return __awaiter$14(this, void 0, void 0, function () {
            var contract;
            return __generator$14(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new UIntSetSpec(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.getValues = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getValues
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.first = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.first
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.last = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.last
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.lastRemove = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastRemove
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.lastPop = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastPop
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.indexOf = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.indexOf
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.size = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.size
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.get = function (index, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.get
                .call(index, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.contains = function (value, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.contains
                .call(value, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    UIntSetSpec.prototype.lastAdd = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.lastAdd
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return UIntSetSpec;
}(soltsice.SoltsiceContract));



var index$1 = Object.freeze({
	AddressSetLib: AddressSetLib,
	AddressSetSpec: AddressSetSpec,
	Bytes32SetLib: Bytes32SetLib,
	Bytes32SetSpec: Bytes32SetSpec,
	Destructible: Destructible,
	EventStore: EventStore,
	EventStoreFactory: EventStoreFactory,
	EventStoreLib: EventStoreLib,
	Migrations: Migrations,
	Ownable: Ownable,
	PackageManager: PackageManager,
	StringUtils: StringUtils,
	UIntSetLib: UIntSetLib,
	UIntSetSpec: UIntSetSpec
});

// FACTORY
var FACTORY = ['NEW_OWNER', 'RECYCLED_TO', 'ES_CREATED'];
var NEW_OWNER = 'NEW_OWNER';
var RECYCLED_TO = 'RECYCLED_TO';
var ES_CREATED = 'ES_CREATED';
// STORE
var STORE = ['NEW_OWNER', 'RECYCLED_TO', 'WL_SET'];
var WL_SET = 'WL_SET';
// ALL
var ALL = STORE.concat(FACTORY);


var InternalEventTypes = Object.freeze({
	FACTORY: FACTORY,
	NEW_OWNER: NEW_OWNER,
	RECYCLED_TO: RECYCLED_TO,
	ES_CREATED: ES_CREATED,
	STORE: STORE,
	WL_SET: WL_SET,
	ALL: ALL
});

var __assign = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var initialState = {
    readModelStoreKey: '',
    readModelType: 'EventStoreFactory',
    contractAddress: '0x0000000000000000000000000000000000000000',
    lastEvent: null,
    model: {} // where all the updates from events will be made
};
var updatesFromMeta = function (meta) {
    return {
        lastEvent: meta.id
    };
};
var handlers = (_a = {}, _a[ES_CREATED] = function (state, action) {
        // console.log(action)
        return __assign({}, state, { model: __assign({}, state.model, (_a = {}, _a[action.payload.value] = {
                created: action.meta.created,
                owner: action.meta.txOrigin
            }, _a)) }, updatesFromMeta(action.meta));
        var _a;
    }, _a);
var reducer = function (state, action) {
    if (handlers[action.type]) {
        return handlers[action.type](state, action);
    }
    return state;
};
var _a;

var Reducer = {
    reducer: reducer,
    initialState: initialState
};

var __awaiter$15 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$15 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};

(function (Factory) {
    var _this = this;
    /**
     * Factory create
     */
    Factory.create = function (web3, fromAddress) { return __awaiter$15(_this, void 0, void 0, function () {
        var instance;
        return __generator$15(this, function (_a) {
            switch (_a.label) {
                case 0:
                    soltsice.W3.Default = web3;
                    return [4 /*yield*/, EventStoreFactory.New(soltsice.W3.TC.txParamsDefaultDeploy(fromAddress), {
                            _multisig: fromAddress
                        })];
                case 1:
                    instance = _a.sent();
                    return [2 /*return*/, instance];
            }
        });
    }); };
    /**
     * Factory createStore
     */
    Factory.createStore = function (factory, whitelist, web3, fromAddress) { return __awaiter$15(_this, void 0, void 0, function () {
        var receipt, events, factoryEvents;
        return __generator$15(this, function (_a) {
            switch (_a.label) {
                case 0:
                    soltsice.W3.Default = web3;
                    return [4 /*yield*/, factory.createEventStore(whitelist, soltsice.W3.TC.txParamsDefaultDeploy(fromAddress))];
                case 1:
                    receipt = _a.sent();
                    return [4 /*yield*/, getFSAsFromReceipt(receipt)];
                case 2:
                    events = _a.sent();
                    factoryEvents = filterEventsByMeta(events, 'msgSender', toChecksumAddress(fromAddress));
                    return [2 /*return*/, EventStore.At(factoryEvents[0].payload.value)];
            }
        });
    }); };
    Factory.getEventStores = function (factory, fromAddress) { return __awaiter$15(_this, void 0, void 0, function () {
        var addresses;
        return __generator$15(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, factory.getEventStores(soltsice.W3.TC.txParamsDefaultDeploy(fromAddress))];
                case 1:
                    addresses = _a.sent();
                    return [2 /*return*/, addresses];
            }
        });
    }); };
    /**
     * Factory getReadModel
     */
    Factory.getReadModel = function (factory, adapter, readModelAdapter, web3, fromAddress) { return __awaiter$15(_this, void 0, void 0, function () {
        var state, factoryReadModel, changes;
        return __generator$15(this, function (_a) {
            switch (_a.label) {
                case 0:
                    state = JSON.parse(JSON.stringify(Reducer.initialState));
                    state.contractAddress = factory.address;
                    state.readModelStoreKey = state.readModelType + ":" + state.contractAddress;
                    factoryReadModel = new ReadModel(readModelAdapter, Reducer.reducer, state);
                    return [4 /*yield*/, factoryReadModel.sync(factory, adapter, web3)];
                case 1:
                    changes = _a.sent();
                    return [2 /*return*/, factoryReadModel];
            }
        });
    }); };
})(exports.Factory || (exports.Factory = {}));

var __awaiter$16 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$16 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};


(function (Store) {
    var _this = this;
    // useful when changing web3 providers...
    Store.get = function (address, web3) { return __awaiter$16(_this, void 0, void 0, function () {
        return __generator$16(this, function (_a) {
            return [2 /*return*/, EventStore.At(address, web3)];
        });
    }); };
    /**
     * Store eventCount
     */
    Store.eventCount = function (store) { return __awaiter$16(_this, void 0, void 0, function () {
        var countBigNumber;
        return __generator$16(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.eventCount()];
                case 1:
                    countBigNumber = _a.sent();
                    return [2 /*return*/, countBigNumber.toNumber()];
            }
        });
    }); };
    Store.transferOwnership = function (store, from, to) { return __awaiter$16(_this, void 0, void 0, function () {
        var receipt, events;
        return __generator$16(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.transferOwnership(to.toLowerCase(), soltsice.W3.TC.txParamsDefaultDeploy(from.toLowerCase()))];
                case 1:
                    receipt = _a.sent();
                    events = getFSAsFromReceipt(receipt);
                    return [2 /*return*/, events];
            }
        });
    }); };
    /**
     * Store readFSA
     */
    Store.readFSA = function (store, eventStoreAdapter, web3, eventId) { return __awaiter$16(_this, void 0, void 0, function () {
        var solidityValues, esEvent;
        return __generator$16(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.readEvent(eventId)];
                case 1:
                    solidityValues = _a.sent();
                    return [4 /*yield*/, valuesToEsEvent(solidityValues[0], solidityValues[1], solidityValues[2], solidityValues[3], solidityValues[4], solidityValues[5], solidityValues[6], solidityValues[7], solidityValues[8])];
                case 2:
                    esEvent = _a.sent();
                    return [2 /*return*/, eventStoreAdapter.eventMap.EsEvent(esEvent)];
            }
        });
    }); };
    /**
     * Store writeFSA
     */
    Store.writeFSA = function (store, eventStoreAdapter, web3, fromAddress, event) { return __awaiter$16(_this, void 0, void 0, function () {
        return __generator$16(this, function (_a) {
            if (typeof event.payload === 'string') {
                throw new Error('event.payload must be an object, not a string.');
            }
            if (Array.isArray(event.payload)) {
                throw new Error('event.payload must be an object, not an array.');
            }
            return [2 /*return*/, eventStoreAdapter.writeFSA(store, fromAddress, event)];
        });
    }); };
    Store.writeFSAs = function (store, eventStoreAdapter, web3, fromAddress, events) { return __awaiter$16(_this, void 0, void 0, function () {
        var writtenEvents, i, event_1, _a, _b;
        return __generator$16(this, function (_c) {
            switch (_c.label) {
                case 0:
                    writtenEvents = [];
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < events.length)) return [3 /*break*/, 4];
                    event_1 = events[i];
                    _b = (_a = writtenEvents).push;
                    return [4 /*yield*/, Store.writeFSA(store, eventStoreAdapter, web3, fromAddress, event_1)];
                case 2:
                    _b.apply(_a, [_c.sent()]);
                    _c.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, writtenEvents];
            }
        });
    }); };
    Store.readFSAs = function (store, eventStoreAdapter, web3, eventIndex) {
        if (eventIndex === void 0) { eventIndex = 0; }
        return __awaiter$16(_this, void 0, void 0, function () {
            var endIndex, events, i, _a, _b;
            return __generator$16(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, Store.eventCount(store)];
                    case 1:
                        endIndex = _c.sent();
                        events = [];
                        i = eventIndex;
                        _c.label = 2;
                    case 2:
                        if (!(i < endIndex)) return [3 /*break*/, 5];
                        _b = (_a = events).push;
                        return [4 /*yield*/, Store.readFSA(store, eventStoreAdapter, web3, i)];
                    case 3:
                        _b.apply(_a, [_c.sent()]);
                        _c.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, Promise.all(events)];
                }
            });
        });
    };
})(exports.Store || (exports.Store = {}));

var __awaiter$17 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$17 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};

(function (Interceptor) {
    var _this = this;
    Interceptor.apply = function (transform, events) { return __awaiter$17(_this, void 0, void 0, function () {
        return __generator$17(this, function (_a) {
            return [2 /*return*/, Promise.all(events.map(function (event) {
                    return transform(event);
                }))];
        });
    }); };
    Interceptor.applyAll = function (transforms, events) { return __awaiter$17(_this, void 0, void 0, function () {
        var mutatedEvents, i;
        return __generator$17(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mutatedEvents = events;
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < transforms.length)) return [3 /*break*/, 4];
                    return [4 /*yield*/, Interceptor.apply(transforms[i], mutatedEvents)];
                case 2:
                    mutatedEvents = _a.sent();
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [4 /*yield*/, Promise.all(mutatedEvents)];
                case 5: return [2 /*return*/, _a.sent()];
            }
        });
    }); };
})(exports.Interceptor || (exports.Interceptor = {}));

var __assign$1 = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var FSATypes;
(function (FSATypes) {
    FSATypes[FSATypes["Native"] = 0] = "Native";
    FSATypes[FSATypes["SimpleKeyValue"] = 1] = "SimpleKeyValue";
    FSATypes[FSATypes["Adapter"] = 2] = "Adapter";
})(FSATypes || (FSATypes = {}));
var getFSAType = function (fsa) {
    if (isNativeEvent(fsa)) {
        return FSATypes.Native;
    }
    if (isSimpleStringKeyValue(fsa)) {
        return FSATypes.SimpleKeyValue;
    }
    if (isAdapterEvent(fsa)) {
        return FSATypes.Adapter;
    }
    throw new Error('Unknown FSAType.');
};
var payloadKeyToKeyType = {
    address: 'A',
    bytes32: 'B',
    uint: 'U' // not good.
};
var isNativeEvent = function (fsa) {
    return payloadKeyToKeyType[fsa.payload.key] !== undefined && fsa.payload.value !== undefined;
};
var isSimpleStringKeyValue = function (fsa) {
    var keys = Object.keys(fsa.payload);
    return (keys.length === 2 &&
        fsa.payload.key !== undefined &&
        fsa.payload.value !== undefined &&
        fsa.payload.key.length < 32 &&
        fsa.payload.value.length < 32);
};
var isAdapterEvent = function (fsa) {
    return payloadKeyToKeyType[fsa.payload.key] === undefined;
};
var getFSAsFromReceipt = function (receipt) {
    var fsa = [];
    receipt.logs.forEach(function (event) {
        if (event.event === 'EsEvent') {
            fsa.push(esEventToFSA(event.args));
        }
    });
    return fsa;
};
var filterEventsByMeta = function (events, prop, propValue) {
    var fsa = [];
    events.forEach(function (event) {
        if (event.meta[prop] === propValue) {
            fsa.push(event);
        }
    });
    return fsa;
};
var valuesToEsEvent = function (Id, TxOrigin, MsgSender, Created, EventType, KeyType, ValueType, Key, Value) {
    return {
        Id: Id,
        TxOrigin: TxOrigin,
        MsgSender: MsgSender,
        Created: Created,
        EventType: EventType,
        KeyType: KeyType,
        ValueType: ValueType,
        Key: Key,
        Value: Value
    };
};
var getFSAFromEsEventWithPartial = function (esEvent, partialFSA) {
    var payload;
    switch (partialFSA.meta.valueType) {
        case 'A':
            payload = {
                key: 'address',
                value: toChecksumAddress('0x' + esEvent.Value.split('0x000000000000000000000000')[1])
            };
            break;
        case 'B':
            payload = {
                key: 'bytes32',
                value: esEvent.Value
            };
            break;
        case 'U':
            payload = {
                key: 'uint',
                value: hexToNumber(esEvent.Value)
            };
            break;
        case 'S':
            payload = {
                key: toAscii(esEvent.Key),
                value: toAscii(esEvent.Value)
            };
            break;
    }
    return __assign$1({}, partialFSA, { payload: payload });
};
var esEventToFSA = function (esEvent) {
    var partialFSA = {
        type: toAscii(esEvent.EventType),
        payload: {},
        meta: {
            keyType: toAscii(esEvent.KeyType),
            valueType: toAscii(esEvent.ValueType),
            id: esEvent.Id.toNumber(),
            created: esEvent.Created.toNumber(),
            txOrigin: toChecksumAddress(esEvent.TxOrigin),
            msgSender: toChecksumAddress(esEvent.MsgSender),
            isInternal: ALL.indexOf(toAscii(esEvent.EventType)) !== -1
        }
    };
    return getFSAFromEsEventWithPartial(esEvent, partialFSA);
};
var arrayToFSA = function (values) {
    var esEvent = valuesToEsEvent(values[0], values[1], values[2], values[3], values[4], values[5], values[6], values[7], values[8]);
    return esEventToFSA(esEvent);
};


var EventTransformer = Object.freeze({
	get FSATypes () { return FSATypes; },
	getFSAType: getFSAType,
	payloadKeyToKeyType: payloadKeyToKeyType,
	isNativeEvent: isNativeEvent,
	isSimpleStringKeyValue: isSimpleStringKeyValue,
	isAdapterEvent: isAdapterEvent,
	getFSAsFromReceipt: getFSAsFromReceipt,
	filterEventsByMeta: filterEventsByMeta,
	valuesToEsEvent: valuesToEsEvent,
	getFSAFromEsEventWithPartial: getFSAFromEsEventWithPartial,
	esEventToFSA: esEventToFSA,
	arrayToFSA: arrayToFSA
});



var EventTypes = Object.freeze({

});

var TransmuteSolidityEncodingTypes = ['S', 'A', 'B', 'U'];


var EventStoreAdapterTypes = Object.freeze({
	TransmuteSolidityEncodingTypes: TransmuteSolidityEncodingTypes
});

var __assign$2 = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter$18 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$18 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var WRITE_EVENT_GAS_COST = 4000000;
var EventStoreAdapter = /** @class */ (function () {
    function EventStoreAdapter(mapper) {
        var _this = this;
        this.mapper = mapper;
        this.eventMap = {
            EsEvent: function (args) { return __awaiter$18(_this, void 0, void 0, function () {
                var fsa, mutatingEvent, key, value, adaptedEvent, transparentAdaptedEvent;
                return __generator$18(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            fsa = esEventToFSA(args);
                            if (fsa.payload !== undefined) {
                                return [2 /*return*/, fsa];
                            }
                            mutatingEvent = {
                                Key: toAscii(args.Key),
                                KeyType: toAscii(args.KeyType),
                                Value: args.Value,
                                ValueType: toAscii(args.ValueType)
                            };
                            // console.log(mutatingEvent.Value);
                            if (!this.mapper[mutatingEvent.ValueType]) {
                                throw new Error('EventStoreAdapter has not mapper for events of valueType: ' +
                                    mutatingEvent.ValueType);
                            }
                            key = this.mapper[mutatingEvent.ValueType].readIDFromBytes32(mutatingEvent.Value);
                            return [4 /*yield*/, this.mapper[mutatingEvent.ValueType].adapter.getItem(this.mapper[mutatingEvent.ValueType].db, key)];
                        case 1:
                            value = _a.sent();
                            adaptedEvent = __assign$2({}, fsa, { payload: {
                                    key: key,
                                    value: value
                                }, meta: __assign$2({}, fsa.meta, { adapter: mutatingEvent.ValueType }) });
                            transparentAdaptedEvent = __assign$2({}, adaptedEvent, { payload: adaptedEvent.payload.value, meta: __assign$2({}, adaptedEvent.meta, { adapterPayload: {
                                        key: this.mapper[mutatingEvent.ValueType].keyName,
                                        value: adaptedEvent.payload.key
                                    } }) });
                            return [2 /*return*/, transparentAdaptedEvent];
                    }
                });
            }); }
        };
        this.convertFSAPayload = function (fsa) { return __awaiter$18(_this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator$18(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = [{}, fsa];
                        _b = {};
                        _c = {
                            key: this.mapper[fsa.meta.adapter].keyName
                        };
                        return [4 /*yield*/, this.setItem(this.mapper[fsa.meta.adapter].adapter, this.mapper[fsa.meta.adapter].db, fsa.payload)];
                    case 1: return [2 /*return*/, __assign$2.apply(void 0, _a.concat([(_b.payload = (_c.value = _d.sent(), _c), _b)]))];
                }
            });
        }); };
        this.getEsEventParamsFromFSA = function (event) { return __awaiter$18(_this, void 0, void 0, function () {
            var esEventParams, _a, adaptedEvent;
            return __generator$18(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = getFSAType(event);
                        switch (_a) {
                            case FSATypes.Adapter: return [3 /*break*/, 1];
                            case FSATypes.SimpleKeyValue: return [3 /*break*/, 3];
                            case FSATypes.Native: return [3 /*break*/, 4];
                        }
                        return [3 /*break*/, 5];
                    case 1:
                        if (event.meta.adapter === undefined) {
                            throw new Error('fsa.meta.adapter is not defined. be sure to set it when fsa.payload is an object (isAdapterEvent).');
                        }
                        if (this.mapper[event.meta.adapter] === undefined) {
                            throw new Error('mapper not provided for event.meta.adapter: ' + event.meta.adapter);
                        }
                        return [4 /*yield*/, this.convertFSAPayload(event)
                            // console.log("adaptedEvent: ", adaptedEvent);
                        ];
                    case 2:
                        adaptedEvent = _b.sent();
                        // console.log("adaptedEvent: ", adaptedEvent);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: this.mapper[adaptedEvent.meta.adapter].keyName,
                            valueType: adaptedEvent.meta.adapter,
                            valueValue: adaptedEvent.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 3:
                        this.isPayloadMisleading(event);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: event.payload.key,
                            valueType: 'S',
                            valueValue: event.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 4:
                        // throw is format is misleading or wrong...
                        this.isPayloadMisleading(event);
                        esEventParams = {
                            keyType: 'S',
                            keyValue: event.payload.key,
                            valueType: payloadKeyToKeyType[event.payload.key],
                            valueValue: event.payload.value
                        };
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, esEventParams];
                }
            });
        }); };
        this.writeFSA = function (store, fromAddress, event) { return __awaiter$18(_this, void 0, void 0, function () {
            var esEventParams, marshalledEvent, receipt, eventsFromLogs;
            return __generator$18(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (event.type.length > 32) {
                            throw new Error('fsa.type (S) is more than 32 bytes. value length = ' +
                                event.type.length +
                                ' chars');
                        }
                        return [4 /*yield*/, this.getEsEventParamsFromFSA(event)
                            // console.log("hmm: ", esEventParams);
                        ];
                    case 1:
                        esEventParams = _a.sent();
                        return [4 /*yield*/, this.marshal(event.type, esEventParams.keyType, esEventParams.valueType, esEventParams.keyValue, esEventParams.valueValue)
                            // console.log(JSON.stringify(marshalledEvent));
                        ];
                    case 2:
                        marshalledEvent = _a.sent();
                        return [4 /*yield*/, store.writeEvent(marshalledEvent.eventType, marshalledEvent.keyType, marshalledEvent.valueType, marshalledEvent.key, marshalledEvent.value, soltsice.W3.TC.txParamsDefaultDeploy(fromAddress, WRITE_EVENT_GAS_COST))
                            // console.log('receipt', receipt)
                        ];
                    case 3:
                        receipt = _a.sent();
                        return [4 /*yield*/, this.extractEventsFromLogs(receipt.logs)
                            // console.log(eventsFromLogs)
                        ];
                    case 4:
                        eventsFromLogs = _a.sent();
                        // console.log(eventsFromLogs)
                        if (receipt.logs.length > 1) {
                            throw new Error('more than 1 event in write event log...');
                        }
                        return [2 /*return*/, eventsFromLogs[0]];
                }
            });
        }); };
        this.throwOnAdapterTypeCollision = function () {
            _this.mapperKeys.forEach(function (mapperKey) {
                if (TransmuteSolidityEncodingTypes.indexOf(mapperKey) !== -1) {
                    throw new Error('Mapper keys cannot container reserved encoding types: ' +
                        TransmuteSolidityEncodingTypes);
                }
            });
        };
        this.throwOnAdapterTypeConversionUndefined = function () {
            _this.mapperKeys.forEach(function (mapperKey) {
                if (_this.mapper[mapperKey] === undefined ||
                    _this.mapper[mapperKey].readIDFromBytes32 === undefined) {
                    throw new Error('Mapper : ' + mapperKey + ' does not implement IAdapterMapper');
                }
            });
        };
        this.getItem = function (adapter, db, key) { return __awaiter$18(_this, void 0, void 0, function () {
            return __generator$18(this, function (_a) {
                return [2 /*return*/, adapter.getItem(db, key)];
            });
        }); };
        this.setItem = function (adapter, db, value) { return __awaiter$18(_this, void 0, void 0, function () {
            return __generator$18(this, function (_a) {
                return [2 /*return*/, adapter.setItem(db, value)];
            });
        }); };
        this.isPayloadKeySizeSafe = function (keyValue, keyType) {
            // ensure key does not exceed keyType size (bytes32 safety check)
            return keyValue.length <= 32;
        };
        this.isPayloadMisleading = function (event) {
            if (event.payload.key === 'bytes32') {
                if (event.meta.valueType === 'B') {
                    // check length
                    if (event.payload.value.length > 66) {
                        // check hex chars only 0-f/F
                        if (!isHex(event.payload.value)) {
                            throw new Error('solidity bytes32 received invalid hex string: ' +
                                event.payload.value);
                        }
                    }
                }
                if (event.meta.valueType === 'S') {
                    if (event.payload.value.length > 32) {
                        throw new Error('payload value of type (S) is more than 32 bytes. value length = ' +
                            event.payload.value.length +
                            ' chars');
                    }
                }
            }
            if (event.payload.key === 'address') {
                if (!isValidAddress(event.payload.value)) {
                    throw new Error('payload of address type has none address value. ' +
                        event.payload.value +
                        ' is not a valid address.');
                }
            }
        };
        this.convertValueToType = function (_valueType, _value) { return __awaiter$18(_this, void 0, void 0, function () {
            return __generator$18(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (_valueType === 'B') {
                            return [2 /*return*/, _value];
                        }
                        if (!this.mapper[_valueType]) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.mapper[_valueType].writeIDToBytes32(_value)];
                    case 1:
                        _value = _a.sent();
                        _a.label = 2;
                    case 2:
                        // // Left padd ints and addresses for bytes32 equivalence of Solidity casting
                        if (_valueType === 'U' || _valueType === 'A') {
                            _value = bufferToHex(setLengthLeft(_value, 32));
                        }
                        return [2 /*return*/, _value];
                }
            });
        }); };
        this.marshal = function (_eventType, _keyType, _valueType, _key, _value) { return __awaiter$18(_this, void 0, void 0, function () {
            var _a;
            return __generator$18(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = {
                            eventType: _eventType,
                            keyType: _keyType,
                            valueType: _valueType
                        };
                        return [4 /*yield*/, this.convertValueToType(_keyType, _key)];
                    case 1:
                        _a.key = _b.sent();
                        return [4 /*yield*/, this.convertValueToType(_valueType, _value)];
                    case 2: return [2 /*return*/, (_a.value = _b.sent(), _a)];
                }
            });
        }); };
        this.extractEventsFromLogs = function (logs) { return __awaiter$18(_this, void 0, void 0, function () {
            var _this = this;
            return __generator$18(this, function (_a) {
                return [2 /*return*/, Promise.all(logs.map(function (log) { return __awaiter$18(_this, void 0, void 0, function () {
                        return __generator$18(this, function (_a) {
                            return [2 /*return*/, this.eventMap[log.event](log.args)];
                        });
                    }); }))];
            });
        }); };
        this.mapperKeys = Object.keys(mapper);
        this.throwOnAdapterTypeCollision();
        this.throwOnAdapterTypeConversionUndefined();
    }
    return EventStoreAdapter;
}());



var ReadModelTypes = Object.freeze({

});

var jsonLogic = require("json-logic-js");

(function (Logic) {
    Logic.applyJsonLogic = function (rule, state) {
        return jsonLogic.apply(rule, state);
    };
    Logic.applyJsonLogicProjection = function (jsonLogicRule, states) {
        return states.map(function (objState) {
            return Logic.applyJsonLogic(jsonLogicRule, objState);
        });
    };
})(exports.Logic || (exports.Logic = {}));

var jiff = require("jiff");

(function (Patch) {
    Patch.statesToPatches = function (states) {
        var patches = [];
        for (var i = 0; i <= states.length - 2; i++) {
            patches.push(jiff.diff(states[i], states[i + 1]));
        }
        return patches;
    };
    Patch.applyPatches = function (state, patches) {
        var patched = JSON.parse(JSON.stringify(state)); // deep copy
        patches.forEach(function (patch) {
            patched = jiff.patchInPlace(patch, patched);
        });
        return patched;
    };
})(exports.Patch || (exports.Patch = {}));

var __awaiter$19 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$19 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var STATE_REQUIRED_PROPS = [
    'contractAddress',
    'readModelType',
    'readModelStoreKey'
];
var ReadModel = /** @class */ (function () {
    function ReadModel(readModelAdapter, reducer, state, interceptors) {
        var _this = this;
        this.readModelAdapter = readModelAdapter;
        this.reducer = reducer;
        this.state = state;
        this.interceptors = interceptors;
        this.requireStateToHaveDefaultProperties = function (state) {
            STATE_REQUIRED_PROPS.forEach(function (prop) {
                if (state[prop] === undefined ||
                    state[prop] === '' ||
                    state[prop] === '0x0000000000000000000000000000000000000000') {
                    throw new Error("state." + prop + " is not defined. make sure its defined before creating a read model.");
                }
            });
            if (state.readModelStoreKey !==
                state.readModelType + ":" + state.contractAddress) {
                throw new Error("state.readModelStoreKey is not formatted correctly. it should be " + state.readModelType + ":" + state.contractAddress);
            }
        };
        this.applyEvents = function (events) {
            for (var i = 0; i < events.length; i++) {
                var event_1 = events[i];
                _this.state = _this.reducer(_this.state, event_1);
            }
        };
        this.sync = function (store, eventStoreAdapter, web3) { return __awaiter$19(_this, void 0, void 0, function () {
            var changes, backup, _a, e_1, startIndex, events, i;
            return __generator$19(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        changes = false;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        console.warn('read model may be stale.');
                        backup = JSON.parse(JSON.stringify(this.state));
                        _a = this;
                        return [4 /*yield*/, this.readModelAdapter.getItem(this.state.readModelStoreKey)];
                    case 2:
                        _a.state = _b.sent();
                        if (!this.state) {
                            this.state = backup;
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        // this case when we have not persisted a read model before OR
                        // there is a bug is getItem/setItem....
                        changes = true;
                        return [3 /*break*/, 4];
                    case 4:
                        startIndex = this.state.lastEvent !== null ? this.state.lastEvent + 1 : 0;
                        return [4 /*yield*/, exports.Store.readFSAs(store, eventStoreAdapter, web3, startIndex)
                            // Interceptors are used to transform events that have been read from the chain.
                            // encryption, loading, size calcs, etc...
                        ];
                    case 5:
                        events = _b.sent();
                        if (!this.interceptors) return [3 /*break*/, 9];
                        i = 0;
                        _b.label = 6;
                    case 6:
                        if (!(i < this.interceptors.length)) return [3 /*break*/, 9];
                        return [4 /*yield*/, exports.Interceptor.applyAll(this.interceptors, events)];
                    case 7:
                        events = _b.sent();
                        _b.label = 8;
                    case 8:
                        i++;
                        return [3 /*break*/, 6];
                    case 9:
                        changes = changes || events.length > 0;
                        if (!changes) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.applyEvents(events)];
                    case 10:
                        _b.sent();
                        this.readModelAdapter.setItem(this.state.readModelStoreKey, this.state);
                        _b.label = 11;
                    case 11: return [2 /*return*/, changes];
                }
            });
        }); };
        if (readModelAdapter.getItem === undefined) {
            throw new Error('readModelAdapter.getItem is not defined. readModelAdapter must implement IReadModelAdapter');
        }
        if (reducer === undefined) {
            throw new Error('reducer is not defined. pass a reducer to the constructor.');
        }
        if (state === undefined) {
            throw new Error('state is not defined. pass a default state to the constructor.');
        }
        this.requireStateToHaveDefaultProperties(state);
    }
    return ReadModel;
}());

var __assign$3 = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var initialState$1 = {
    readModelStoreKey: '',
    readModelType: 'PackageManager',
    contractAddress: '0x0000000000000000000000000000000000000000',
    lastEvent: null,
    model: {} // where all the updates from events will be made,
};
var updatesFromMeta$1 = function (meta) {
    return {
        lastEvent: meta.id
    };
};
var calculateCostFromRefs = function (refs) {
    var keys = Object.keys(refs);
    var size = 0;
    keys.forEach(function (key) {
        size += refs[key];
    });
    return size;
};
var handlePackageUpdate = function (state, action) {
    var meta = action.meta;
    state.model.adapterMeta = state.model.adapterMeta || {};
    state.model.adapterMeta[meta.valueType] = state.model.adapterMeta[meta.valueType] || {
        eventRefs: {},
        cumulativeEventSize: 0,
        packageRefs: {},
        cumulativePackageSize: 0
    };
    var thisEventAdapterMeta = state.model.adapterMeta[meta.valueType];
    var eventRefs = thisEventAdapterMeta.eventRefs;
    var packageRefs = thisEventAdapterMeta.packageRefs;
    var eventRef = meta.adapterMeta.eventHash;
    var eventSize = meta.adapterMeta.eventSize;
    var packageRef = meta.adapterMeta.packageHash;
    var packageSize = meta.adapterMeta.packageSize;
    eventRefs[eventRef] = eventSize;
    packageRefs[packageRef] = packageSize;
    state.model[packageRef] = action.payload.name;
    thisEventAdapterMeta.cumulativeEventSize = calculateCostFromRefs(eventRefs);
    thisEventAdapterMeta.cumulativePackageSize = calculateCostFromRefs(packageRefs);
    return state.model;
};
var handlePackageDelete = function (state, action) {
    var meta = action.meta;
    state.model.adapterMeta = state.model.adapterMeta;
    var thisEventAdapterMeta = state.model.adapterMeta[meta.valueType];
    var eventRefs = state.model.adapterMeta[meta.valueType].eventRefs;
    var packageRefs = state.model.adapterMeta[meta.valueType].packageRefs;
    var eventRef = meta.adapterMeta.eventHash;
    var eventSize = meta.adapterMeta.eventSize;
    eventRefs[eventRef] = eventSize;
    var packageRef = meta.adapterMeta.packageHash;
    delete packageRefs[packageRef];
    delete state.model[packageRef];
    thisEventAdapterMeta.cumulativeEventSize = calculateCostFromRefs(eventRefs);
    thisEventAdapterMeta.cumulativePackageSize = calculateCostFromRefs(packageRefs);
    return state.model;
};
var handlers$1 = (_a$1 = {}, _a$1[NEW_OWNER] = function (state, action) {
        // console.log(action);
        return __assign$3({}, state, { model: __assign$3({}, state.model, { owner: action.payload.value }) }, updatesFromMeta$1(action.meta));
    }, _a$1[WL_SET] = function (state, action) {
        // console.log(action);
        return __assign$3({}, state, { model: __assign$3({}, state.model, { whitelisted: true }) }, updatesFromMeta$1(action.meta));
    }, _a$1.PACKAGE_UPDATED = function (state, action) {
        // console.log('delets seem bust ', action)
        // make sure to settle object before returning it.
        var newState = __assign$3({}, state, { model: handlePackageUpdate(state, action) }, updatesFromMeta$1(action.meta));
        return newState;
    }, _a$1.PACKAGE_DELETED = function (state, action) {
        // make sure to settle object before returning it.
        // console.log("package deleted events must be interceptor so that meta can be extracted...");
        // console.log(action.meta);
        var newState = __assign$3({}, state, { model: handlePackageDelete(state, action) }, updatesFromMeta$1(action.meta));
        return newState;
    }, _a$1);
var reducer$1 = function (state, action) {
    if (handlers$1[action.type]) {
        state = handlers$1[action.type](state, action);
    }
    return state;
};
var _a$1;

var R = {
    reducer: reducer$1,
    initialState: initialState$1
};

var __awaiter$20 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$20 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var MAPPER_ENCODING = 'I';
var PackageService = /** @class */ (function () {
    function PackageService(relic, packageManager, eventStoreAdapter, readModelAdapter) {
        var _this = this;
        this.relic = relic;
        this.packageManager = packageManager;
        this.eventStoreAdapter = eventStoreAdapter;
        this.readModelAdapter = readModelAdapter;
        this.requireLatestReadModel = function () { return __awaiter$20(_this, void 0, void 0, function () {
            var _a;
            return __generator$20(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.getReadModel()
                            // if (!this.readModel) {
                            //   this.readModel = await this.getReadModel();
                            // } else {
                            //   this.readModel.sync(this.packageManager, this.eventStoreAdapter, this.relic.web3);
                            // }
                        ];
                    case 1:
                        _a.readModel = _b.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.publishPackage = function (multihash, name, fromAddress) { return __awaiter$20(_this, void 0, void 0, function () {
            var events;
            return __generator$20(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.requireLatestReadModel()];
                    case 1:
                        _a.sent();
                        if (this.readModel.state.model[multihash]) {
                            throw new Error('package already exists in read model.');
                        }
                        return [4 /*yield*/, exports.Store.writeFSA(this.packageManager, this.eventStoreAdapter, this.relic.web3, fromAddress, {
                                type: 'PACKAGE_UPDATED',
                                payload: {
                                    name: name,
                                    multihash: multihash
                                },
                                meta: {
                                    adapter: MAPPER_ENCODING
                                }
                            })];
                    case 2:
                        events = _a.sent();
                        return [4 /*yield*/, this.requireLatestReadModel()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, events];
                }
            });
        }); };
        this.deletePackage = function (multihash, fromAddress) { return __awaiter$20(_this, void 0, void 0, function () {
            var event;
            return __generator$20(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.requireLatestReadModel()];
                    case 1:
                        _a.sent();
                        if (!this.readModel.state.model[multihash]) {
                            throw new Error('package does not exist in read model.');
                        }
                        return [4 /*yield*/, exports.Store.writeFSA(this.packageManager, this.eventStoreAdapter, this.relic.web3, fromAddress, {
                                type: 'PACKAGE_DELETED',
                                payload: {
                                    multihash: multihash
                                },
                                meta: {
                                    adapter: MAPPER_ENCODING
                                }
                            })];
                    case 2:
                        event = _a.sent();
                        return [4 /*yield*/, this.requireLatestReadModel()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, event];
                }
            });
        }); };
        this.getReadModel = function () { return __awaiter$20(_this, void 0, void 0, function () {
            var _this = this;
            var state, getStat, getAdapterMetaFromEvent, interceptorChain, changes;
            return __generator$20(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        state = JSON.parse(JSON.stringify(R.initialState));
                        state.contractAddress = this.packageManager.address;
                        state.readModelStoreKey = state.readModelType + ":" + state.contractAddress;
                        getStat = function (mhash) {
                            return new Promise(function (resolve, reject) {
                                _this.eventStoreAdapter.mapper[MAPPER_ENCODING].db.stat(mhash, function (err, result) {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve(result);
                                    }
                                });
                            });
                        };
                        getAdapterMetaFromEvent = function (action) { return __awaiter$20(_this, void 0, void 0, function () {
                            var eventMultihash, eventStat, packageStat;
                            return __generator$20(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        eventMultihash = action.meta.adapterPayload.value;
                                        return [4 /*yield*/, getStat(eventMultihash)];
                                    case 1:
                                        eventStat = _a.sent();
                                        return [4 /*yield*/, getStat(action.payload.multihash)];
                                    case 2:
                                        packageStat = _a.sent();
                                        return [2 /*return*/, {
                                                eventHash: eventMultihash,
                                                eventSize: eventStat.CumulativeSize,
                                                packageHash: action.payload.multihash,
                                                packageSize: packageStat.CumulativeSize
                                            }];
                                }
                            });
                        }); };
                        interceptorChain = [
                            function (event) { return __awaiter$20(_this, void 0, void 0, function () {
                                var _a;
                                return __generator$20(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(event.type === 'PACKAGE_UPDATED')) return [3 /*break*/, 2];
                                            _a = event.meta;
                                            return [4 /*yield*/, getAdapterMetaFromEvent(event)];
                                        case 1:
                                            _a.adapterMeta = _b.sent();
                                            _b.label = 2;
                                        case 2: return [2 /*return*/, event];
                                    }
                                });
                            }); },
                            function (event) { return __awaiter$20(_this, void 0, void 0, function () {
                                var _a;
                                return __generator$20(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(event.type === 'PACKAGE_DELETED')) return [3 /*break*/, 2];
                                            _a = event.meta;
                                            return [4 /*yield*/, getAdapterMetaFromEvent(event)];
                                        case 1:
                                            _a.adapterMeta = _b.sent();
                                            event.meta.updateAdapterMeta = true;
                                            _b.label = 2;
                                        case 2: return [2 /*return*/, event];
                                    }
                                });
                            }); }
                        ];
                        if (!this.readModel) {
                            this.readModel = new ReadModel(this.readModelAdapter, R.reducer, state, interceptorChain);
                        }
                        return [4 /*yield*/, this.readModel.sync(this.packageManager, this.eventStoreAdapter, this.relic.web3)
                            // console.log(JSON.stringify(ipfsReadModel, null, 2))
                        ];
                    case 1:
                        changes = _a.sent();
                        // console.log(JSON.stringify(ipfsReadModel, null, 2))
                        return [2 /*return*/, this.readModel];
                }
            });
        }); };
        // console.log("created...");
    }
    return PackageService;
}());

// Import here Polyfills if needed. Recommended core-js (npm i -D core-js)
// import "core-js/fn/array.find"
// ...

exports.Relic = Relic;
exports.Utils = index;
exports.TransmuteContracts = index$1;
exports.W3 = soltsice.W3;
exports.AddressSetLib = AddressSetLib;
exports.AddressSetSpec = AddressSetSpec;
exports.Bytes32SetLib = Bytes32SetLib;
exports.Bytes32SetSpec = Bytes32SetSpec;
exports.Destructible = Destructible;
exports.EventStore = EventStore;
exports.EventStoreFactory = EventStoreFactory;
exports.EventStoreLib = EventStoreLib;
exports.Migrations = Migrations;
exports.Ownable = Ownable;
exports.PackageManager = PackageManager;
exports.StringUtils = StringUtils;
exports.UIntSetLib = UIntSetLib;
exports.UIntSetSpec = UIntSetSpec;
exports.InternalEventTypes = InternalEventTypes;
exports.EventTransformer = EventTransformer;
exports.EventTypes = EventTypes;
exports.EventStoreAdapterTypes = EventStoreAdapterTypes;
exports.EventStoreAdapter = EventStoreAdapter;
exports.TransmuteSolidityEncodingTypes = TransmuteSolidityEncodingTypes;
exports.ReadModelTypes = ReadModelTypes;
exports.ReadModel = ReadModel;
exports.PackageService = PackageService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=transmute-framework.umd.js.map
